//+++
//
// CLASS: Dae1sRequest
//
// CLASS DESCRIPTION: 
//
// Request packet for DAE IS
//
//---
 
#ifndef DAE1SREQUEST_HXX
#define DAE1SREQUEST_HXX

class Dae1sRequest : public DaeRequest
{
public:
      // DESCRIPTION: The multibus address on the DAE 
      fort_i4 busAddress;
      // DESCRIPTION: The number of words to transfer
      fort_i4 nWords;
      // DESCRIPTION: Controls whether to access the IO space or the memory
      AccessMode accessMode;
      // DESCRIPTION: 
      fort_i2* buffer;
 
      // DESCRIPTION: 
      //  PRECOND: 
      //  POSTCOND: 
       Dae1sRequest (TransferMode t_mode, fort_i4 bus_address, fort_i2* buff, fort_i4 nwrds, AccessMode a_mode);
      // DESCRIPTION: 
      //  PRECOND: 
      //  POSTCOND: 
       ~Dae1sRequest ();
      Status insert (daeTransfer_t *transfer_buffer, int position);
      Status retrieve (daeTransfer_t *transfer_buffer, int position);
      // DESCRIPTION: 
      //  PRECOND: 
      //  POSTCOND: 
// in units of DaeTransfer_t
      int getSendSize ();
      int getTotalSize ();
      void print(ostream& os);
};
 
ostream& operator<<(ostream& os, Dae1sRequest& request);

#endif	/* DAE1SREQUEST_HXX */
