#include <dce/pthread.h>
#include <iostream.h>
#include <string.h>
#include "types.hxx"
#include "vms_status.hxx"
#include "status.hxx"
#include "daepacketheader.hxx"

int DaePacketHeader::getHeaderSize() const
{
    return headerSize;
}

int DaePacketHeader::getPacketSize() const
{
    return packetSize;
}

void DaePacketHeader::setPacketSize(int size)
{
    packetSize = size + headerSize;
    return;
}

Status DaePacketHeader::insert(daeTransfer_t* transfer_buffer, int offset) const
{
    daeTransfer_t array[4];
    array[0] = requestType;
    array[1] = majorVersionNumber;
    array[2] = minorVersionNumber;
    array[3] = packetSize * sizeof(idl_long_int);
    memcpy(transfer_buffer+offset, array, headerSize*sizeof(daeTransfer_t)); 
    return Status();
}

DaePacketHeader::DaePacketHeader()
{
    requestType = DAE1S;
    majorVersionNumber = 1;
    minorVersionNumber = 0;
    headerSize = 4;
    packetSize = headerSize / sizeof(idl_long_int);
}

DaePacketHeader::DaePacketHeader(const void* data)
{
    fort_i4* data_p = (fort_i4*)data;
    requestType = (RequestType)data_p[0];
    majorVersionNumber = data_p[1];
    minorVersionNumber = data_p[2];
    packetSize = data_p[3];
}

void DaePacketHeader::print(ostream& os) const
{
    os << "*** Packet Header details ***\n";
    os << "Request Type = " << requestType << "\n";
    os << "Major version number = " << majorVersionNumber << "\n";
    os << "Minor version number = " << minorVersionNumber << "\n";
    os << "Packet size = " << packetSize << " 4 byte words\n";
}    

ostream& operator<<(ostream& os, DaePacketHeader& header)
{
    header.print(os);
    return os;
}
