//+++
//
// CLASS: DaePacketHeader
//
// CLASS DESCRIPTION: 
//
// This is the general header to add to everything sent to the DAE
//
//---
 
#ifndef DAEPACKETHEADER_HXX
#define DAEPACKETHEADER_HXX

class DaePacketHeader
{
public:
      RequestType requestType;
      // DESCRIPTION: This will be 1 for DAE1s, 2 or more for DAEII
      fort_i4 majorVersionNumber;
      // DESCRIPTION: 
      fort_i4 minorVersionNumber;
      // DESCRIPTION: In terms of daeTransfer_t
      fort_i4 packetSize;
      // DESCRIPTION: 
      fort_i4 headerSize;
 
      // DESCRIPTION: in units of daeTransfer_t
      //  PRECOND: 
      //  POSTCOND: 
      int getHeaderSize() const;
      // DESCRIPTION: in units of daeTransfer_t
      //  PRECOND: 
      //  POSTCOND: 
      int getPacketSize() const;
      // DESCRIPTION: 
      //  PRECOND: 
      //  POSTCOND: 
      Status insert(daeTransfer_t *transfer_buffer, int position) const;
      // DESCRIPTION: 
      //  PRECOND: 
      //  POSTCOND: 
       DaePacketHeader();
      // DESCRIPTION: 
      //  PRECOND: 
      //  POSTCOND: 
       DaePacketHeader(const void *data);

      void setPacketSize (int size);
      void print(ostream& os) const;
};

ostream& operator<<(ostream& os, DaePacketHeader& header);

#endif /* DAEPACKETHEADER_HXX  */
