C
C OPEN_DAE
C
C Author: 	Freddie Akeroyd
C
C *** A Fortran 77 routine to call the "C" open_dae routine
C *** Needs to pack a string into an integer array
C *** for later unpacking
C
C *** Also defines an auxiliary function TRUELEN
C
      INTEGER*4 FUNCTION OPEN_DAE(DEVICE)
      IMPLICIT NONE
      INTEGER*4 SIZE
      PARAMETER(SIZE=128)
      INTEGER*4 I, LENGTH, IDEVICE(SIZE+1), OPEN_DAE_, TRUELEN
      BYTE B(4*SIZE)
      CHARACTER*(*) DEVICE
      EQUIVALENCE (B(1), IDEVICE(2))
      EXTERNAL OPEN_DAE_, TRUELEN
      INTRINSIC ICHAR
      LENGTH = TRUELEN(DEVICE)
C *** +1 to allow for null termination
      IF (LENGTH+1 .GT. 4*SIZE) THEN
          WRITE(6,20) 'OPEN_DAE: Name length of ', 
     1                LENGTH, ' characters is too long'
          OPEN_DAE = 0
          RETURN
      ENDIF
      IDEVICE(1) = LENGTH
      DO I = 1, LENGTH
          B(I) = ICHAR(DEVICE(I:I))
      ENDDO
C *** Null terminate the string
      B(LENGTH+1) = 0
      OPEN_DAE = OPEN_DAE_(IDEVICE)
      RETURN
 20   FORMAT(A,I5,A)
      END
C
C *** Return the length if a string after discarding blanks at end
C
      INTEGER*4 FUNCTION TRUELEN(STRING)
      IMPLICIT NONE
      CHARACTER*(*) STRING
      INTEGER*4 I
      INTRINSIC LEN
      I = LEN(STRING)
 10   IF (STRING(I:I) .EQ. ' ') THEN
         I = I - 1
         IF (I. GT. 0) GOTO 10
      ENDIF
      TRUELEN = I
      RETURN
      END
C
