//
//  Module:	RIO_EDESCRIP.HXX 
//  
//  Function:	Error module for the RioLibrary class  
//	          
//
//  Author:	Freddie Akeroyd
//

#ifndef RIO_EDESCRIPT_HXX

#define RIO_EDESCRIPT_HXX

#include "status.hxx"
#include "edescrip_defs.hxx"

enum error_icode
{
	NIL,										    // NIL error, must be present.
	OUT_OF_MEMORY,
	A_DAE_OPEN,
	NO_DAE_OPEN,
	BAD_WORD_LENGTH,
	RPC_ERROR,
	SERVER_NOT_LISTENING,
	INVALID_CONTEXT_HANDLE
};

static int FCODE;
static edescrip fac_edescrips[] = 

{ 
edescrip(   FCODE,		    "RioLibrary"       					     	),  // Module descriptor.
edescrip(   OUT_OF_MEMORY,	    "Cannot allocate space for @ in @",			ERROR   ),
edescrip(   A_DAE_OPEN,		    "Cannot connect to @ as currently connected to @",	ERROR	),
edescrip(   NO_DAE_OPEN,	    "Cannot release DAE, it is not accessed",		ERROR	),
edescrip(   BAD_WORD_LENGTH,	    "Cannot use word length of @ bytes",		ERROR	),
edescrip(   RPC_ERROR,		    "RPC error: @ - @",					ERROR	),
edescrip(   SERVER_NOT_LISTENING,   "Dae server is not responding",			ERROR	),
edescrip(   INVALID_CONTEXT_HANDLE, "Dae server returned an invalid context handle",	ERROR	)
};

static edescrip_module_init not_used(fac_edescrips);

#endif	/* RIO_EDESCRIPT_HXX */
