#include <dce/pthread.h>
#include <string.hxx>
#include "debug.hxx"
#include "riolibrary_debug.hxx"

/*
 * these codes need to be declared "extern int" in the header
 */
// Individial codes
int DEBUG_G_RIO_OPEN, DEBUG_G_RIO_CLOSE, DEBUG_G_RIO_RESET;
int DEBUG_G_RIO_READ_MEM, DEBUG_G_RIO_READ_IO, DEBUG_G_RIO_WRITE_MEM, DEBUG_G_RIO_WRITE_IO;
int DEBUG_G_RIO_READ_CRPT;
int DEBUG_G_RIO_REQUESTS;
// groups
int DEBUG_G_RIO_ALL, DEBUG_G_RIO_READ, DEBUG_G_RIO_WRITE;
int DEBUG_G_RIO_DEFAULT;

int debug_rio_init()
{
    static g_debug_dummy_class rio_debug_a
    (
    	g_debug_init("RIO_Open", DEBUG_G_RIO_OPEN),
    	g_debug_init("RIO_Close", DEBUG_G_RIO_CLOSE),
    	g_debug_init("RIO_Reset", DEBUG_G_RIO_RESET),
    	g_debug_init("RIO_ReadMem", DEBUG_G_RIO_READ_MEM),
    	g_debug_init("RIO_WriteMem", DEBUG_G_RIO_WRITE_MEM),
    	g_debug_init("RIO_ReadIO", DEBUG_G_RIO_READ_IO),
    	g_debug_init("RIO_WriteIO", DEBUG_G_RIO_WRITE_IO),
    	g_debug_init("RIO_ReadCRPT", DEBUG_G_RIO_READ_CRPT),
    	g_debug_init("RIO_Requests", DEBUG_G_RIO_REQUESTS)
    );
    {
	static int DEBUG_GARRAY_RIO_ALL[] = { DEBUG_G_RIO_OPEN, DEBUG_G_RIO_CLOSE, DEBUG_G_RIO_RESET, DEBUG_G_END };
	static int DEBUG_GARRAY_RIO_READ[] = { DEBUG_G_RIO_READ_MEM, DEBUG_G_RIO_READ_IO, DEBUG_G_RIO_READ_CRPT, DEBUG_G_END };
	static int DEBUG_GARRAY_RIO_WRITE[] = { DEBUG_G_RIO_WRITE_MEM, DEBUG_G_RIO_WRITE_IO, DEBUG_G_END };
	static int DEBUG_GARRAY_RIO_DEFAULT[] = { DEBUG_G_RIO_RESET, DEBUG_G_END };

	static g_debug_dummy_class rio_debug_b
	(
	    g_debug_init("DEFAULT", DEBUG_G_RIO_DEFAULT, DEBUG_GARRAY_RIO_DEFAULT),
    	    g_debug_init("RIO_All", DEBUG_G_RIO_ALL, DEBUG_GARRAY_RIO_ALL),
    	    g_debug_init("RIO_AllReads", DEBUG_G_RIO_READ, DEBUG_GARRAY_RIO_READ),
	    g_debug_init("RIO_AllWrites", DEBUG_G_RIO_WRITE, DEBUG_GARRAY_RIO_WRITE)
	);
    }
    return 0;
}
