//  Module:	VMS_STATUS.HXX
//  
//  Function:	Class implementations for VMS private status objects.
//		These are used to keep error context information from VMS system calls.
//		Once returned from VMS, we can base them around inside Status variables.
//		We include the string representation in the object itself, so that a client
//		running another O/S can return the information without having a local message directory.
//
//  Author:	R.Brodie 28/4/93

#ifndef	    VMS_STATUS_LOADED
#define	    VMS_STATUS_LOADED 1

#include <string.hxx>
#include <iostream.h>
#include "status.hxx"

class VMSErrorObject : public AbstractErrorObject
    {
    friend class Status;
    
    public: //    VMSErrorObject(void);
		VMSErrorObject(int icode_i);				// Only import the message code.  
		~VMSErrorObject(void);					// System services don't return F$FAO type values.
//		VMSErrorObject::operator=(const VMSErrorObject& v_eobj);		
		int isNormal(void) const;
		int Errlevel(void) const;    

    protected:	void print(ostream& stream) const;	

    private:	String message_string;
    };

#endif	//  VMS_STATUS_LOADED
