/***********************************************************************
 *
 *	Public definitions for calling in to Smalltalk.
 *
 *	$Revision: 1.5 $
 *	$Date: 1997/04/02 22:15:43 $
 *	$Author: faa $
 *
 ***********************************************************************/


/***********************************************************************
 *
 * Copyright (C) 1992, 1994, 1995 Free Software Foundation, Inc.
 * Written by Steve Byrne.
 *
 * This file is part of GNU Smalltalk.
 *
 * GNU Smalltalk is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 1, or (at your option) any later 
 * version.
 * 
 * GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
 * Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
 *
 ***********************************************************************/

/*
 *    Change Log
 * ============================================================================
 * Author      Date       Change 
 * sbb	     11 Jul 95	  Added defineCFunc.
 *
 * sbb	     23 Jun 95	  Switched to GST header guard prefix.
 *
 * sbb	      6 Jun 95	  Switched to new file naming scheme.
 *
 * sbb	      5 Jun 95	  Merged in Brad Diller's changes.
 *
 * sbb	      1 Jan 92	  Created.
 *
 */


#ifndef __GSTPUB__
#define __GSTPUB__

#ifndef __GST__
#include "gst.h"
#endif /* __GST__ */

#if defined(HAVE_VARARGS_H)
# define __PVARGS(args) ()
#else
# define __PVARGS(args) __P(args)
#endif

extern OOP	msgSend __PVARGS ((OOP receiver, OOP selector __DOTS));
extern OOP	strMsgSend __PVARGS ((OOP receiver __DOTS));

extern void	msgSendf __PVARGS ((voidPtr resultPtr __DOTS));

extern OOP      registerOOP(OOP oop), evalExpr(char *str);
extern void	unregisterOOP(OOP oop), initSmalltalk(void), smalltalkArgs __P((int, char**)),
		topLevelLoop(void), pseudoTopLevelLoop(void),
		defineCFunc(char *funcName, void (*funcAddr) (/* ??? */));

/* Convert C datatypes to Smalltalk types */

extern OOP	intToOOP(long i), floatToOOP(double f), boolToOOP(int b), charToOOP(char c),
		stringToOOP(const char* str), symbolToOOP(char* str), cObjectToOOP(voidPtr co), 
		typeNameToOOP(const char* name);

/* Convert Smalltalk datatypes to C data types */

extern long	OOPToInt(OOP oop); 
extern double	OOPToFloat(OOP oop);
extern int 	OOPToBool(OOP oop);
extern char	OOPToChar(OOP oop);
extern char	*OOPToString(OOP oop);
extern voidPtr	OOPToCObject(OOP oop);

/* SBB: these two interfaces are not permanent -- they will go away when weak refs/finalization becomes available */
/* brd Mon Jan 23 22:48:01 GMT-0800 1995 */

extern void *mstGetCdata(OOP oop);
extern OOP mstMalloc(OOP receiver, size_t byteSize);

#if defined(GC_TORTURE)
extern void	startGCTorture(void), stopGCTorture(void);
#endif


#endif /* __GSTPUB__ */
