/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

//+++
//
// CLASS: H_err_bars
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class H_err_bars : public Plot
{
      // DESCRIPTION: array of X values for upper error bars
      private: float* X_upper_array;
      // DESCRIPTION: array of X values of lower end of error bar
      private: float* X_lower_array;
      // DESCRIPTION: length or error bar terminator
      private: float end_size;
      // DESCRIPTION: default end size
      // 
      public: static float  END_SIZE;
 
      // DESCRIPTION: draws the object on the picture
      //  PRECOND: object must be declared
      //  POSTCOND: object is in display list
      public: void display ();
      // DESCRIPTION: constructor for +/- errors equal
      //  PRECOND:  
      //  POSTCOND:  
      public:   H_err_bars (int,double*,double*, double*,float end=-1.0,
		    int colour=-1,int thick=0);
      // DESCRIPTION: constructor for diff +/- errors
      //  PRECOND:  
      //  POSTCOND:  
      public: H_err_bars (int,double*,double*,double*,double*,
		float end=-1.0,int colour=-1,int thick=0);
      // DESCRIPTION: destructor
      //  PRECOND:  
      //  POSTCOND:  
      public: virtual  ~H_err_bars ( );
};
