/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

//+++
//
// CLASS: Multiplot
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class Multiplot : public Plot
{
      // DESCRIPTION: 2 dimensional array of Y values
      // dimensions are [NHIST][NCHAN]
      public: float *Y_2d_array;
      private: int counter;
      // DESCRIPTION: number of histograms
      private: int  nhist;
      private: int line_type;
      // DESCRIPTION: slant for 3d effect
      private: int  slant;
      // DESCRIPTION: default slant
      public: static int SLANT;
      // DESCRIPTION: offset between histograms in units of Y
      private: float  gap;
      // DESCRIPTION: 0=bin start, 1=bin centre
      private: int bin_centre;
      // DESCRIPTION: 
      public: static int  BIN_CENTRE;
      // DESCRIPTION: 
      private: int  min_X_chan;
      // DESCRIPTION: 
      private: int  max_X_chan;
      // DESCRIPTION: 
      private: int  total_chan;
      public: static int LINE_TYPE;
      private: float XDL;
      private: float YDL;
      private: float XDU;
      private: float YDU;
      private: float spectra_added;
 
      // DESCRIPTION: constructor
      //  PRECOND:  
      //  POSTCOND:  
      public:  Multiplot (int,double *,int numhist,int minch,int maxch,	\
	float bias,int centre=-1,int colour=-1,int thickness=0,		\
	int type=0);
      // DESCRIPTION: 
      //  PRECOND:  
      //  POSTCOND:  
      public: virtual ~Multiplot ( );
      // DESCRIPTION: 
      //  PRECOND:  
      //  POSTCOND:  
      public: void add_spectra(const double *,int length);
      public: void add_spectra(const int *,int length);
      public: void display ();
      public: void get_size(float& XXM, float& XXN, float& YYM, float& YYN);
};
