/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
// ---------------------
//
// BUFFERING.CC
//
// Controls output buffering of graphics
//
#include "Buffering.h"
#include "Pginclude.h"

static const char* rcsid = "@(#)$Id: buffering.cxx,v 1.5 1997/05/06 09:56:49 cmm Exp $";
USE_RCSID(rcsid);

// DISABLE = always flush when asked (Buffering DISABLED)
// ENABLE =  wait for an explicit rea
// 1 = enable buffering (do not display immediately)
// 0 = disable buffering (display graphics immediately)
enum BufferingSetting { DISABLE=0, ENABLE=1 };

static int CurrentBufferingSetting = DISABLE;	

void start_buffer() {

    pgbbuf();

}

void flush_buffer() {

    if (CurrentBufferingSetting == DISABLE)
    {
        pgupdt();
    }
}

void close_buffer() {

    pgebuf();

}

int set_buffer_update(int enable_buffering)
{
    int old_buffering_value = CurrentBufferingSetting;
    if (enable_buffering == 0)
    {
	CurrentBufferingSetting = DISABLE;
	flush_buffer();
    }
    else if (enable_buffering == 1)
    {
	CurrentBufferingSetting = ENABLE;
    }
    return old_buffering_value;
}
