/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef CONTOUR_LABELS_H
#define CONTOUR_LABELS_H

class ContourPlot;

class ContourLabels : public Drawable_objects
{
    protected:
	ContourPlot* m_plot;
	String m_label;
	pg_int m_start;
	pg_int m_end;
	pg_int m_step;
	pg_int m_intval;
	pg_int m_minint;
	pg_int m_font;
	pg_float m_height;

    public:
	ContourLabels(ContourPlot* last_contour_plot, const char* label, int start, int end, int step, 
			int intval, int minint, int colour, int font, float height, float line_width);
	void function(pg_int& visible_in, pg_float& x_in, pg_float& y_in, pg_float& z_in, pg_int& visible_out, 
			pg_float& x_out, pg_float& y_out);
 	virtual void display();
};

#endif /* CONTOUR_LABELS_H */
