/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
// -----------------------------------------------------------------------------
// DRAW_ERRORS.C
//
// Description: C++ code to allow creation of a Genie object-graphics error
//  bars plot

#include "Genie_functions.h"

// *** includes for the picture list
#include "Pictlist.h"

// *** local includes
#include "Plot.h"
#include "V_err_bars.h"
#include "H_err_bars.h"

static const char* rcsid = "@(#)$Id: draw_errors.cxx,v 1.6 1997/04/08 16:32:31 cmm Exp $";
USE_RCSID(rcsid);

    void new_errors(int npts,
			double *xarray,
			double *yarray,
			double *earray,
			int colour,
			int vert,
			float linewidth,
			g_objectid objid) {


	Drawable_objects *PTR = 0;
	float fzero = 0.0F;
	int width;

	// *** convert line width to an integer
	width = (int)linewidth;

	// *** new VERT or HORIZ error bars
	if (vert == 1)
		PTR = new V_err_bars(npts,xarray,yarray,earray,1.0F,colour,width);	

	if (vert == 0)
		PTR = new H_err_bars(npts,xarray,yarray,earray,1.0F,colour,width);	


	// *** add them to the display list
	objid[ObjectPosition] = PicturePTR[Current_Picture]->disp_add(PTR);
	objid[ObjectPicture] = Current_Picture;

    }

    void draw_errors(int npts,
                        double *xarray,
                        double *yarray,
                        double *earray,
                        int colour,
                        int vert,
                        float linewidth) {

    g_integer objid[GENIE_OBJECTID_SIZE];
    new_errors(npts, xarray, yarray, earray, colour, vert, linewidth, objid);
    display_object(objid);

    }


