/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
// -----------------------------------------------------------------------------
// DRAW_PLOT.C
//
// Description: C++ code to allow creation of a Genie object-graphics polyline.
//
#include "Genie_functions.h"

// *** includes for the picture list
#include "Pictlist.h"

// *** local includes
#include "Plot.h"
#include "Polyline.h"

static const char* rcsid = "@(#)$Id: draw_plot.cxx,v 1.5 1997/04/08 16:32:35 cmm Exp $";
USE_RCSID(rcsid);

    void new_plot(int npts,
			double *xarray,
			double *yarray,
			int colour,
			int type,
			float linewidth,
			g_objectid objid) {


	Drawable_objects *PTR;
	float fzero = 0.0F;
	int width;

	// *** convert line width to an integer
	width = (int)linewidth;

	// *** NEW an object
	PTR = new Polyline(npts,xarray,yarray,type,colour,width);	

	// *** add them to the display list
	objid[ObjectPosition] = PicturePTR[Current_Picture] ->disp_add(PTR);
	objid[ObjectPicture] = Current_Picture;


    }

    void draw_plot (int npts,
                        double *xarray,
                        double *yarray,
                        int colour,
                        int type,
                        float linewidth) {
		
    g_integer objid[GENIE_OBJECTID_SIZE];
    new_plot(npts, xarray, yarray, colour, type, linewidth, objid);

    display_object (objid);

    }
