/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
// -----------------------------------------------------------------------------
// DRAW_BOX.C
//
// Description: C++ code to allow creation of a Genie object-graphics polygon.
//
#include "Genie_functions.h"

// *** includes for the picture list
#include "Pictlist.h"

// *** local includes
#include "Polygon.h"

static const char* rcsid = "@(#)$Id: draw_polygon.cxx,v 1.4 1997/04/08 16:32:35 cmm Exp $";
USE_RCSID(rcsid);

void new_polygon(double x[], 
		 double y[], 
		 int numsides, 
		 int colour, 
		 float linewidth, 
		 int solid, 
		 g_objectid objid) 
{

	Drawable_objects *PTR;
	float fzero = 0.0F;
	int width;

	// *** convert line width to an integer
	width = (int)linewidth;

	// *** NEW an object
	PTR = new Polygon(numsides,x,y,solid,colour,width);

	// *** add to the display list
	objid[ObjectPosition] = PicturePTR[Current_Picture]->disp_add(PTR);
	objid[ObjectPicture] = Current_Picture;

    }

void draw_polygon(double x[], 
		  double y[], 
		  int numsides, 
		  int colour, 
		  float linewidth,
 		  int solid)

{

	g_integer objid[GENIE_OBJECTID_SIZE];
	new_polygon(x, y, numsides, colour, linewidth, solid, objid);
	display_object(objid);

}
