/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*
 *      Module:         ferror
 *      Author:         Freddie Akeroyd, ISIS
 *      Purpose:        FORTRAN interface to C++ error handling class
 *
 */
#include "geniedefs.h"
/*
 * ferror_link is called from fortran function ferror_add in ferror_add.for
 */

#if defined(HAVE_LIBF2C)
#define ferror_link ferror_link__
#elif defined(__unix)
#define ferror_link ferror_link_
#endif

typedef struct simple { 
    int length; 
    char spot[512]; 
    } STRING;

static const char* rcsid = "@(#)$Id: ferror.cxx,v 1.6 1997/05/06 09:56:54 cmm Exp $";
USE_RCSID(rcsid);

#include "Genie_functions.h"	/* for prototype of error_add */

extern "C" {
    void ferror_link(STRING*, STRING*, STRING*);
    }

void ferror_link(STRING *iobj, STRING *ifail, STRING *isoln)
{
    error_add(iobj->spot, ifail->spot, isoln->spot);
    return;
}
