/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef FLOAT_CONVERT
#define FLOAT_CONVERT

/* this is to allow the routines to be called from fortran */
#if defined(HAVE_LIBF2C)
#define ieee_to_vax_float ieee_to_vax_float__
#define vax_to_ieee_float vax_to_ieee_float__
#define vaxf_to_local vaxf_to_local__
#define local_to_vaxf local_to_vaxf__
#elif defined(__unix)
#define ieee_to_vax_float ieee_to_vax_float_
#define vax_to_ieee_float vax_to_ieee_float_
#define vaxf_to_local vaxf_to_local_
#define local_to_vaxf local_to_vaxf_
#endif /* __unix */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* these routines return 0 = success, 1 = failure */

/* convert an IEEE single float to VAX F FLOAT format */
/* int ieee_to_vax_float(float* fp); */

/* convert VAX F FLOAT into an IEEE single float */
/* int vax_to_ieee_float(float* fp); */

/* convert float array val[n] to and from vax float */
void vaxf_to_local(float *val, const int *n, int *errcode);
void local_to_vaxf(float *val, const int *n, int *errcode);

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* FLOAT_CONVERT */
