/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef FORKINIT_H
#define FORKINIT_H

/*
 * define the macro FORKINIT to do any initialisation needed before a fork()
 */

#ifdef __VMS_POSIX
#   define String XString			    /* X declares a String which conflicts with C++ */
#   include <X11/Intrinsic.h>			    /* used by initForkContext() only */
#   undef String
#   define FORKINIT(__argv) initForkContext(__argv)

    /*
     * Used only on VMS/POSIX to initialize the fork callbacks when linked with Decwindows/Motif.
     */
    static void initForkContext(char** argv)
    {
	XtAppContext ap;
	int argc(1);
	Display* display = XOpenDisplay(NULL);
	if (display != 0)
	{
	    XCloseDisplay(display);
	    XtAppInitialize(&ap, "Genie", NULL, 0, &argc, argv, NULL, NULL, 0);
	    XtDestroyApplicationContext(ap);
	}
	else
	{
	    printf("No X display set - please set one and restart GENIE\n");
	    exit(1);
	}
	return;
    }

#else
#   define FORKINIT(__argv)				    /* only somthing on VMS */
#endif /* __VMS_POSIX */

#endif /* FORKINIT_H */
