/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef __G_FORTEXTERN__
#define __G_FORTEXTERN__

#include "fortran_types.h"

/* for gcl write command with no filename */
#define	DEFAULT_FORTRAN_OUTPUT_UNIT	15
#define	DEFAULT_FORTRAN_INPUT_UNIT	16

#include "Pginclude.h"

/* Header file for external fortran routines
 *
 *   In partciular, the GET/DATA command
 *
 *   These callouts are likely to be essential to the working of GENIE as
 *   a whole and should not be altered without a good understanding of what
 *   is going on!
 */

#if defined(HAVE_LIBF2C)
	#define read_data read_data___
	#define open_data_file open_data_file___
	#define close_data_file close_data_file__
	#define default_file_name default_file_name___
	#define tran_out tran_out___
	#define tran_in tran_in___
	#define read_int read_int___
	#define write_int write_int___
	#define func_in func_in___
	#define func_out func_out___
	#define load_in load_in___
	#define load_out load_out___
	#define GETPARI	getpari___
	#define GETPARR	getparr___
	#define GETPARC	getparc___
	#define GETDAT getdat___
	#define TRUNCATE_FILE truncate_file__
	#define GINFO_C ginfo_c__
#elif defined(__VMS)
	#define read_data read_data_
	#define open_data_file open_data_file_
	#define default_file_name default_file_name_
	#define tran_out tran_out_
	#define tran_in tran_in_
	#define read_int read_int_
	#define write_int write_int_
	#define func_in func_in_
	#define func_out func_out_
	#define load_in load_in_
	#define load_out load_out_
	#define GETPARI	getpari_
	#define GETPARR	getparr_
	#define GETPARC	getparc_
	#define GETDAT getdat_
	#define TRUNCATE_FILE truncate_file
	#define GINFO_C ginfo_c
#elif defined(__unix)
	#define read_data read_data__
	#define open_data_file open_data_file__
	#define close_data_file close_data_file_
	#define default_file_name default_file_name__
	#define tran_out tran_out__
	#define tran_in tran_in__
	#define read_int read_int__
	#define write_int write_int__
	#define func_in func_in__
	#define func_out func_out__
	#define load_in load_in__
	#define load_out load_out__
	#define GETPARI	getpari__
	#define GETPARR	getparr__
	#define GETPARC	getparc__
	#define GETDAT getdat__
	#define TRUNCATE_FILE truncate_file_
	#define GINFO_C ginfo_c_
#endif

extern "C" {
	void read_data(const STRING&,fort_int&, const fort_int&,fort_real[],
	               fort_int[],fort_real[],fort_real[],const fort_int&,
		       fort_real[],fort_int[],const fort_int&,fort_real&,
		       fort_real&,fort_real&,fort_real&,fort_real&,STRING&,
	               fort_real&,STRING&,STRING&,STRING&,STRING&,fort_real[], 
		       fort_int&, fort_int&);
	void open_data_file(STRING&,fort_int&,fort_int&,fort_int&,fort_int&);
	void close_data_file();
	void default_file_name(fort_int&, STRING&);
	void tran_out(fort_int&, fort_int&, fort_real[], fort_real[], fort_real[],
		      STRING&, STRING&, STRING&, fort_real&, fort_int&,
		      STRING&, fort_int&, fort_int&, fort_real&, fort_real&,
		      fort_real&, fort_int&, fort_int&, STRING&, fort_real&,
		      STRING&, fort_real&, fort_real[], fort_real[], STRING&, fort_int&);
	void tran_in(fort_int&, fort_int&, fort_real[], fort_real[], fort_real[],
		      STRING&, STRING&, STRING&, fort_real&, fort_int&,
		      STRING&, fort_int&, fort_int&, fort_real&, fort_real&,
		      fort_real&, fort_int&, fort_int&, STRING&, fort_real&,
		      STRING&, fort_real&, fort_real[], fort_real[], STRING&, fort_int&);
	void read_int(fort_int&,STRING&,fort_int&,fort_int&,fort_real[],fort_real[],
		     fort_real[],fort_int&,fort_int&,fort_int&,fort_real&,
		     fort_int&,fort_int&,fort_int&,fort_int&,fort_real&,
		     fort_real&,fort_real&,fort_real&,fort_real&,fort_real&,
		     STRING&,STRING&,STRING&,STRING&,STRING&,STRING&,STRING&,
		     fort_int&, fort_real*, fort_int&);
	void write_int(fort_int&,STRING&,fort_int&,fort_int&,fort_real[],fort_real[],
		     fort_real[],fort_int&,fort_int&,fort_int&,fort_real&,
		     fort_int&,fort_int&,fort_int&,fort_int&,fort_real&,
		     fort_real&,fort_real&,fort_real&,fort_real&,fort_real&,
		     STRING&,STRING&,STRING&,STRING&,STRING&,STRING&,STRING&,
		     fort_int&, fort_int&, STRING&, fort_int&, fort_real*, fort_int&);
	void func_in(fort_int&, fort_real*, fort_real*, STRING&, STRING&, STRING&, 
	     		fort_int&, fort_int&, fort_real*, fort_real*, STRING&, fort_int&);
	void func_out(fort_int&, fort_real*, fort_real*, fort_real*, STRING&, STRING&, STRING&, 
	      		fort_real&, fort_real&, fort_real&, fort_real&, fort_real&, fort_real*, 
	      		fort_real*, fort_int&, fort_int&, STRING&, fort_int&);
	void load_out(STRING&, fort_int&);
	void load_in(fort_int&, fort_real[], fort_real[], fort_real[],
		      STRING&, STRING&, STRING&, fort_real&, fort_int&,
		      STRING&, fort_int&, fort_int&, fort_real&, fort_real&,
		      fort_real&, fort_int&, fort_int&, STRING&, fort_real&,
		      STRING&, fort_real&, fort_real[], fort_real[], STRING&, fort_int&);
	void GINFO_C(STRING& imessage);
	}

/* define internal function codes for this facility */
typedef enum {
    FreddieFortranTest = 0,
    FortranGetSNSSpectrum = 1,
    FortranGetSNSItem = 2,
    FortranGetDefaultFilename = 3,
    FortranWriteSpectrum = 4,
    FortranMultiGetSNSSpectrum = 5,
    FortranImportSpectrum = 6,
    FortranExportSpectrum = 7,
    FortranReadSpectrum = 8,
    FortranNSpectrum = 9,
    FortranDirIntFile = 10,
    FortranWriteG3File = 11,
    FortranRunUserProg = 12,
    FortranLoadOut = 13,
    FortranFileType = 14,
    ReadLine = 15,
    LinesInFile = 16,
    OpenStream = 17,
    CloseStream = 18,
    WriteIntermediateFile = 19,
    DirectoryIntermediateFile = 20,
    ReadOldGenieIntermediateFile = 21,
    FocusSpectrumRange = 22,
    ReadIntermediateFile = 23,
    ReadAscii = 24,
    ReadAsciiStream = 25,
    WriteAscii = 26,
    WriteAsciiStream = 27,
    GetSNSSpectrumArray = 28,
    LengthIntermediateFile = 29,
    GetSNSMultiSpectrum = 30,
    WriteGenieASCII = 31,
    ReadGenieASCII = 32
} fortran_function_code;

typedef enum {
    FortranWriteBinary = 1,
    FortranWriteAscii = 2
} fortran_write_mode;

typedef enum {
    FortranOpenAppend = 1,
    FortranOpenNew = 2
} fortran_open_mode;

typedef enum {
    G2Style = 2,
    G3Style = 3
} fortran_write_style;

/* Prototypes */


OOP g_fortextern( fortran_function_code function, OOP parameters );

fort_real* arrayAllocCopyFReal(g_variable, const char*, g_integer);

void arrayDeallocPutFReal(g_variable, const char*, fort_real[], g_integer);

int fortranWriteG3File(String file, g_integer mode, g_variable gv_to_write, 
		       const char* marker, g_variable *g_nbytes, g_variable *g_blocks);

int fortranWriteG2File(String file, g_integer mode, g_variable gv_to_write, 
		       g_variable *g_nbytes, g_variable *g_blocks);

int g2ReadSpectrum(String file, g_variable* spectrum, g_integer block, g_integer* blocks);

int g2NSpectrum(String file, g_integer *nspectrum);

int g3NSpectrum(String file, g_integer *nspectrum);

int dirG3IntFile(String file, g_integer iopt, g_variable *directory, g_variable *sizes, g_variable *nspec);

int g3ReadBlock(const char* file, g_integer block, const char *marker, int imode, g_variable *gv, g_integer *blocks);

int get_spectrum(String& runid, fort_int spec, fort_int* ya, fort_int npoints, int ngroup);

int multiGetSNSSpectrum(String file, g_integer istart, g_integer iend, g_integer iopt, 
	fort_int ntcmax, fort_int ntc, fort_int ndetmax, fort_int nuse, g_variable *spectrum);

#define OPEN_DATA_FILE(str1, i1, i2, i3, i4) {\
	    int& _i1 = i1;\
	    int& _i2 = i2;\
	    int& _i3 = i3;\
	    int& _i4 = i4;\
	    PGDESCRIPTOR(_str1,str1);\
	    String one = str1; \
	    open_data_file(_str1, _i1, _i2, _i3, _i4);\
	}
		
#define DEFAULT_FILE_NAME(i1, str1) { \
		int& _i1 = i1; \
	    	String& s1 = str1;\
	    	PGDESCRIPTOR(_s1,s1);\
		default_file_name(_i1, _s1);\
	    	s1 = _s1.spot; \
	}

#define READ_DATA(s1, i1, i2, f1, i3, f2, f3, i4, \
		  f4, i5, i6, f5, f6, f7, f8, f11, str2, \
		  f9, str3, str4, str5, str6, f10, i7, i8) {\
	    float*  _f1 = f1;\
	    float*  _f2 = f2;\
	    float*  _f3 = f3;\
	    float*  _f4 = f4;\
	    float& _f5 = f5;\
	    float& _f6 = f6;\
	    float& _f7 = f7;\
	    float& _f8 = f8;\
	    float& _f9 = f9;\
	    float* _f10 = f10;\
	    float& _f11 = f11;\
	    int& _i1 = i1;\
	    const int& _i2 = i2;\
	    int*  _i3 = i3;\
	    int& _i4 = i4;\
	    int*  _i5 = i5;\
	    const int& _i6 = i6;\
	    int& _i7 = i7;\
	    int& _i8 = i8;\
	    PGDESCRIPTOR(_s1,s1);\
	    String one = s1; \
	    String& s2 = str2;\
	    PGDESCRIPTOR(_s2,s2);\
	    String& s3 = str3;\
	    PGDESCRIPTOR(_s3,s3);\
	    String& s4 = str4;\
	    PGDESCRIPTOR(_s4,s4);\
	    String& s5 = str5;\
	    PGDESCRIPTOR(_s5,s5);\
	    String& s6 = str6;\
	    PGDESCRIPTOR(_s6,s6);\
	    read_data(_s1, _i1, _i2, _f1, _i3, _f2, _f3, _i4, \
	      	      _f4, _i5, _i6, _f5, _f6, _f7, _f8, _f11, _s2, \
		      _f9, _s3, _s4, _s5, _s6, _f10, _i7, _i8); \
	    s2 = _s2.spot; \
	    s3 = _s3.spot; \
	    s4 = _s4.spot; \
	    s5 = _s5.spot; \
	    s6 = _s6.spot; \
	}

#define TRAN_OUT(i1, i2, f1, f2, f3, str1, str2, str3, f4, i3, str4, \
		 i4, i5, f5, f6, f7, i6, i7, str5, f8, str6, f9, f10, f11, str7, i8) { \
	    int& _i1 = i1; \
	    int& _i2 = i2; \
	    int& _i3 = i3; \
	    int& _i4 = i4; \
	    int& _i5 = i5; \
	    int& _i6 = i6; \
	    int& _i7 = i7; \
	    int& _i8 = i8; \
	    float* _f1 = f1; \
	    float* _f2 = f2; \
	    float* _f3 = f3; \
	    float& _f4 = f4; \
	    float& _f5 = f5; \
	    float& _f6 = f6; \
	    float& _f7 = f7; \
	    float& _f8 = f8; \
	    float& _f9 = f9; \
	    float* _f10 = f10; \
	    float* _f11 = f11; \
	    String& s1 = str1;\
	    PGDESCRIPTOR(_s1,s1);\
	    String& s2 = str2;\
	    PGDESCRIPTOR(_s2,s2);\
	    String& s3 = str3;\
	    PGDESCRIPTOR(_s3,s3);\
	    String& s4 = str4;\
	    PGDESCRIPTOR(_s4,s4);\
	    String& s5 = str5;\
	    PGDESCRIPTOR(_s5,s5);\
	    String& s6 = str6;\
	    PGDESCRIPTOR(_s6,s6);\
	    String& s7 = str7;\
	    PGDESCRIPTOR(_s7,s7);\
	    tran_out(_i1, _i2, _f1, _f2, _f3, _s1, _s2, _s3, _f4, _i3, _s4, \
		     _i4, _i5, _f5, _f6, _f7, _i6, _i7, _s5, _f8, _s6, _f9, _f10, _f11, _s7, _i8); \
	    s1 = _s1.spot; \
	    s2 = _s2.spot; \
	    s3 = _s3.spot; \
	    s4 = _s4.spot; \
	    s5 = _s5.spot; \
	    s6 = _s6.spot; \
	    s7 = _s7.spot; \
	}

#define TRAN_IN(i1, i2, f1, f2, f3, str1, str2, str3, f4, i3, str4, \
		 i4, i5, f5, f6, f7, i6, i7, str5, f8, str6, f9, f10, f11, str7, i8) { \
	    int& _i1 = i1; \
	    int& _i2 = i2; \
	    int& _i3 = i3; \
	    int& _i4 = i4; \
	    int& _i5 = i5; \
	    int& _i6 = i6; \
	    int& _i7 = i7; \
	    int& _i8 = i8; \
	    float* _f1 = f1; \
	    float* _f2 = f2; \
	    float* _f3 = f3; \
	    float& _f4 = f4; \
	    float& _f5 = f5; \
	    float& _f6 = f6; \
	    float& _f7 = f7; \
	    float& _f8 = f8; \
	    float& _f9 = f9; \
	    float* _f10 = f10; \
	    float* _f11 = f11; \
	    String& s1 = str1;\
	    PGDESCRIPTOR(_s1,s1);\
	    String& s2 = str2;\
	    PGDESCRIPTOR(_s2,s2);\
	    String& s3 = str3;\
	    PGDESCRIPTOR(_s3,s3);\
	    String& s4 = str4;\
	    PGDESCRIPTOR(_s4,s4);\
	    String& s5 = str5;\
	    PGDESCRIPTOR(_s5,s5);\
	    String& s6 = str6;\
	    PGDESCRIPTOR(_s6,s6);\
	    String& s7 = str7;\
	    PGDESCRIPTOR(_s7,s7);\
	    tran_in(_i1, _i2, _f1, _f2, _f3, _s1, _s2, _s3, _f4, _i3, _s4, \
		     _i4, _i5, _f5, _f6, _f7, _i6, _i7, _s5, _f8, _s6, _f9, _f10, _f11, _s7, _i8); \
	    s1 = _s1.spot; \
	    s2 = _s2.spot; \
	    s3 = _s3.spot; \
	    s4 = _s4.spot; \
	    s5 = _s5.spot; \
	    s6 = _s6.spot; \
	    s7 = _s7.spot; \
	}

#define READ_INT(i1, str1, i2, i11, f1, f2, f3, i3, i4, i5, f4, i6, i7, i8, i9, \
		 f5, f6, f7, f8, f9, f10, str2, str3, str4, str5, str6, str7, str8, \
		 i10, f11, i12) { \
	    int& _i1 = i1; \
	    int& _i2 = i2; \
	    int& _i3 = i3; \
	    int& _i4 = i4; \
	    int& _i5 = i5; \
	    int& _i6 = i6; \
	    int& _i7 = i7; \
	    int& _i8 = i8; \
	    int& _i9 = i9; \
	    int& _i10 = i10; \
	    int& _i11 = i11; \
	    int& _i12 = i12; \
	    float* _f1 = f1; \
	    float* _f2 = f2; \
	    float* _f3 = f3; \
	    float& _f4 = f4; \
	    float& _f5 = f5; \
	    float& _f6 = f6; \
	    float& _f7 = f7; \
	    float& _f8 = f8; \
	    float& _f9 = f9; \
	    float& _f10 = f10; \
	    float* _f11 = f11; \
	    String& s1 = str1;\
	    PGDESCRIPTOR(_s1,s1);\
	    String& s2 = str2;\
	    PGDESCRIPTOR(_s2,s2);\
	    String& s3 = str3;\
	    PGDESCRIPTOR(_s3,s3);\
	    String& s4 = str4;\
	    PGDESCRIPTOR(_s4,s4);\
	    String& s5 = str5;\
	    PGDESCRIPTOR(_s5,s5);\
	    String& s6 = str6;\
	    PGDESCRIPTOR(_s6,s6);\
	    String& s7 = str7;\
	    PGDESCRIPTOR(_s7,s7);\
	    String& s8 = str8;\
	    PGDESCRIPTOR(_s8,s8);\
	    read_int(_i1, _s1, _i2, _i11, _f1, _f2, _f3, _i3, _i4, _i5, _f4, _i6, _i7, _i8, _i9, \
		 _f5, _f6, _f7, _f8, _f9, _f10, _s2, _s3, _s4, _s5, _s6, _s7, _s8, \
		 _i10, _f11, _i12);  \
	    s1 = _s1.spot; \
	    s2 = _s2.spot; \
	    s3 = _s3.spot; \
	    s4 = _s4.spot; \
	    s5 = _s5.spot; \
	    s6 = _s6.spot; \
	    s7 = _s7.spot; \
	    s8 = _s8.spot; \
	}

#define WRITE_INT(i1, str1, i2, i11, f1, f2, f3, i3, i4, i5, f4, i6, i7, i8, i9, \
		 f5, f6, f7, f8, f9, f10, str2, str3, str4, str5, str6, str7, str8, \
		 i10, i12, str9, i13, f11, i14) { \
	    int& _i1 = i1; \
	    int& _i2 = i2; \
	    int& _i3 = i3; \
	    int& _i4 = i4; \
	    int& _i5 = i5; \
	    int& _i6 = i6; \
	    int& _i7 = i7; \
	    int& _i8 = i8; \
	    int& _i9 = i9; \
	    int& _i10 = i10; \
	    int& _i11 = i11; \
	    int& _i12 = i12; \
	    int& _i13 = i13; \
	    int& _i14 = i14; \
	    float* _f1 = f1; \
	    float* _f2 = f2; \
	    float* _f3 = f3; \
	    float& _f4 = f4; \
	    float& _f5 = f5; \
	    float& _f6 = f6; \
	    float& _f7 = f7; \
	    float& _f8 = f8; \
	    float& _f9 = f9; \
	    float& _f10 = f10; \
	    float* _f11 = f11; \
	    String& s1 = str1;\
	    PGDESCRIPTOR(_s1,s1);\
	    String& s2 = str2;\
	    PGDESCRIPTOR(_s2,s2);\
	    String& s3 = str3;\
	    PGDESCRIPTOR(_s3,s3);\
	    String& s4 = str4;\
	    PGDESCRIPTOR(_s4,s4);\
	    String& s5 = str5;\
	    PGDESCRIPTOR(_s5,s5);\
	    String& s6 = str6;\
	    PGDESCRIPTOR(_s6,s6);\
	    String& s7 = str7;\
	    PGDESCRIPTOR(_s7,s7);\
	    String& s8 = str8;\
	    PGDESCRIPTOR(_s8,s8);\
	    String& s9 = str9;\
	    PGDESCRIPTOR(_s9,s9);\
	    write_int(_i1, _s1, _i2, _i11, _f1, _f2, _f3, _i3, _i4, _i5, _f4, _i6, _i7, _i8, _i9, \
		 _f5, _f6, _f7, _f8, _f9, _f10, _s2, _s3, _s4, _s5, _s6, _s7, _s8, \
		 _i10, _i12, _s9, _i13, _f11, _i14);  \
	    s1 = _s1.spot; \
	    s2 = _s2.spot; \
	    s3 = _s3.spot; \
	    s4 = _s4.spot; \
	    s5 = _s5.spot; \
	    s6 = _s6.spot; \
	    s7 = _s7.spot; \
	    s8 = _s8.spot; \
	    s9 = _s9.spot; \
	}

#define FUNC_IN(i1, f1, f2, str1, str2, str3, i2, i3, f3, f4, str4, i4) { \
	    int& _i1 = i1; \
	    int& _i2 = i2; \
	    int& _i3 = i3; \
	    int& _i4 = i4; \
	    float* _f1 = f1; \
	    float* _f2 = f2; \
	    float* _f3 = f3; \
	    float* _f4 = f4; \
	    String& s1 = str1;\
	    PGDESCRIPTOR(_s1,s1);\
	    String& s2 = str2;\
	    PGDESCRIPTOR(_s2,s2);\
	    String& s3 = str3;\
	    PGDESCRIPTOR(_s3,s3);\
	    String& s4 = str4;\
	    PGDESCRIPTOR(_s4,s4);\
	    func_in(_i1, _f1, _f2, _s1, _s2, _s3, _i2, _i3, _f3, _f4, _s4, _i4); \
	    s1 = _s1.spot; \
	    s2 = _s2.spot; \
	    s3 = _s3.spot; \
	    s4 = _s4.spot; \
	}


#define FUNC_OUT(i1, f1, f2, f3, str1, str2, str3, f4, f5, f6, f7, f8, f9, f10, i2, i3, str4, i4) { \
	    int& _i1 = i1; \
	    int& _i2 = i2; \
	    int& _i3 = i3; \
	    int& _i4 = i4; \
	    float* _f1 = f1; \
	    float* _f2 = f2; \
	    float* _f3 = f3; \
	    float& _f4 = f4; \
	    float& _f5 = f5; \
	    float& _f6 = f6; \
	    float& _f7 = f7; \
	    float& _f8 = f8; \
	    float* _f9 = f9; \
	    float* _f10 = f10; \
	    String& s1 = str1;\
	    PGDESCRIPTOR(_s1,s1);\
	    String& s2 = str2;\
	    PGDESCRIPTOR(_s2,s2);\
	    String& s3 = str3;\
	    PGDESCRIPTOR(_s3,s3);\
	    String& s4 = str4;\
	    PGDESCRIPTOR(_s4,s4);\
	    func_out(_i1, _f1, _f2, _f3, _s1, _s2, _s3, _f4, _f5, _f6, _f7, \
		     _f8, _f9, _f10, _i2, _i3, _s4, _i4); \
	    s1 = _s1.spot; \
	    s2 = _s2.spot; \
	    s3 = _s3.spot; \
	    s4 = _s4.spot; \
	}

#define LOAD_IN(i2, f1, f2, f3, str1, str2, str3, f4, i3, str4, \
		 i4, i5, f5, f6, f7, i6, i7, str5, f8, str6, f9, f10, f11, str7, i8) { \
	    int& _i2 = i2; \
	    int& _i3 = i3; \
	    int& _i4 = i4; \
	    int& _i5 = i5; \
	    int& _i6 = i6; \
	    int& _i7 = i7; \
	    int& _i8 = i8; \
	    float* _f1 = f1; \
	    float* _f2 = f2; \
	    float* _f3 = f3; \
	    float& _f4 = f4; \
	    float& _f5 = f5; \
	    float& _f6 = f6; \
	    float& _f7 = f7; \
	    float& _f8 = f8; \
	    float& _f9 = f9; \
	    float* _f10 = f10; \
	    float* _f11 = f11; \
	    String& s1 = str1;\
	    PGDESCRIPTOR(_s1,s1);\
	    String& s2 = str2;\
	    PGDESCRIPTOR(_s2,s2);\
	    String& s3 = str3;\
	    PGDESCRIPTOR(_s3,s3);\
	    String& s4 = str4;\
	    PGDESCRIPTOR(_s4,s4);\
	    String& s5 = str5;\
	    PGDESCRIPTOR(_s5,s5);\
	    String& s6 = str6;\
	    PGDESCRIPTOR(_s6,s6);\
	    String& s7 = str7;\
	    PGDESCRIPTOR(_s7,s7);\
	    load_in(_i2, _f1, _f2, _f3, _s1, _s2, _s3, _f4, _i3, _s4, \
		     _i4, _i5, _f5, _f6, _f7, _i6, _i7, _s5, _f8, _s6, _f9, _f10, _f11, _s7, _i8); \
	    s1 = _s1.spot; \
	    s2 = _s2.spot; \
	    s3 = _s3.spot; \
	    s4 = _s4.spot; \
	    s5 = _s5.spot; \
	    s6 = _s6.spot; \
	    s7 = _s7.spot; \
	}

#define LOAD_OUT(str1, i1) { \
	    int& _i1 = i1; \
	    String& s1 = str1;\
	    PGDESCRIPTOR(_s1,s1);\
	    load_out(_s1, _i1);\
	    s1 = _s1.spot;\
	}

int getSNSItem(String& runid, GenieString& item, GenieVariable& gv);
extern "C" {
void GETPARI(STRING& frunid, STRING& fitem, fort_int* buffer, fort_int& length_in, fort_int& length_out, fort_int& errcode);
void GETPARR(STRING& frunid, STRING& fitem, fort_real* buffer, fort_int& length_in, fort_int& length_out, fort_int& errcode);
void GETPARC(STRING& frunid, STRING& fitem, STRING& fcitem, fort_int& length, fort_int& errcode);
void GETDAT(STRING& frunid, fort_int& ifsn, fort_int& nos, fort_int* idata, fort_int& length, fort_int& errrcode);
void TRUNCATE_FILE(STRING& file);
}
#endif /* __G_FORTEXTERN__ */
