/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef __G_OPERATIONS__
#define __G_OPERATIONS__

/* Header file for builtin parts of GENIE to be called by smalltalk
 *
 *   These callouts are likely to be essential to the working of GENIE as
 *   a whole and should not be altered without a good understanding of what
 *   is going on!
 */

/* define internal function codes for this facility */
/* start at 0 so they tie up with operation_function_names[] */
typedef enum {
    Operation_test = 0,
    GXRealarray_extend = 1,
    GXIntegerarray_extend = 2,
    GXIntegerarray_asFloat = 3,
    GXRealarray_collect_hint = 4,
    GXRealarray_with_collect_hint = 5,
    GXRealarray_equals = 6,
    GXIntegerarray_collect_hint = 7,
    GXIntegerarray_with_collect_hint = 8,
    GXIntegerarray_equals = 9,
    GXIntegerarray_shallowCopy = 10,
    GXRealarray_shallowCopy = 11,
    GXRealarray_max = 12,
    GXRealarray_min = 13,
    GXRealarray_sum = 14,
    GXIntegerarray_max = 15,
    GXIntegerarray_min = 16,
    GXIntegerarray_sum = 17,
    GXRealarray_fix = 18,
    GXIntegerarray_fix = 19,
    GXRealarray_at = 20,
    GXRealarray_at_put = 21,
    GXIntegerarray_at = 22,
    GXIntegerarray_at_put = 23,
    GXRealarray_element_size = 24,
    GXIntegerarray_element_size = 25,
    GXIntegerarray_extend_with_mode = 26,
    GXRealarray_extend_with_mode = 27,
    GXIntegerarray_unfix = 28,
    GXRealarray_unfix = 29,
    GXIntegerarrayCopyFromTo = 30,
    GXRealarrayCopyFromTo = 31,
    GXIntegerarrayReplaceFromToWithStartingAt = 32,
    GXRealarrayReplaceFromToWithStartingAt = 33,
    GXIntegerarray_apply_function = 34,
    GXRealarray_apply_function = 35,
    GXRealarray_centre = 36,
    GXRealarray_cut = 37,
    GXRealarray_bracket = 38
} operation_function_code;

// Tie up with operation_function_code enum
static const char* operation_function_names[] =
{
    "Operation_test",
    "GXRealarray_extend",
    "GXIntegerarray_extend",
    "GXIntegerarray_asFloat",
    "GXRealarray_collect_hint",
    "GXRealarray_with_collect_hint",
    "GXRealarray_equals",
    "GXIntegerarray_collect_hint",
    "GXIntegerarray_with_collect_hint",
    "GXIntegerarray_equals",
    "GXIntegerarray_shallowCopy",
    "GXRealarray_shallowCopy",
    "GXRealarray_max",
    "GXRealarray_min",
    "GXRealarray_sum",
    "GXIntegerarray_max",
    "GXIntegerarray_min",
    "GXIntegerarray_sum",
    "GXRealarray_fix",
    "GXIntegerarray_fix",
    "GXRealarray_at",
    "GXRealarray_at_put",
    "GXIntegerarray_at",
    "GXIntegerarray_at_put",
    "GXRealarray_element_size",
    "GXIntegerarray_element_size",
    "GXIntegerarray_extend_with_mode",
    "GXRealarray_extend_with_mode",
    "GXIntegerarray_unfix",
    "GXRealarray_unfix",
    "GXIntegerarrayCopyFromTo",
    "GXRealarrayCopyFromTo",
    "GXIntegerarrayReplaceFromToWithStartingAt",
    "GXRealarrayReplaceFromToWithStartingAt",
    "GXIntegerarray_apply_function",
    "GXRealarray_apply_function",
    "GXRealarray_centre",
    "GXRealarray_cut",
    "GXRealarray_bracket"
};

/* Prototype */
OOP g_operations( operation_function_code function, OOP arguments );

#endif /* __G_OPERATIONS__ */
