/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef G_TKTCL
#define G_TKTCL

#include <tk.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

int Genie_Tcl_AppInit(Tcl_Interp* interp);

#ifdef HAVE_LIBTIX
int Tix_Init(Tcl_Interp *interp);
#endif /* HAVE_LIBTIX */

#ifdef __cplusplus
}
#endif /* __cplusplus */

/* Structures for tk PGPLOT driver */
typedef struct
{
    Tk_Uid cmd;
    Tcl_CmdInfo cmdinfo;
    Tk_Window tkwin;
    Tcl_Interp* interp;
    int opened;		/* 1 if PGOPEN done on this window */
} PGTkItem;

extern Tcl_Interp* PGTkDefaultInterp;

#define MAX_PGTKITEMS	6		/* Max num of open TK devices */
extern PGTkItem* PGTkItemList[];   	/* length MAX_PGTKITEMS */
/* PGTkItemList[i] != 0 --> i is a valid device number */

#endif /* G_TKTCL */
