/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef GENIE_SPECTRUM
#define GENIE_SPECTRUM

class GenieSpectrum;

class GenieSpectrum : public GenieWorkspace
{
public:
    GenieSpectrum(int nfields /*= 1*/) : GenieWorkspace(nfields) {};
    GenieSpectrum(OOP oop /*= nilOOP*/) : GenieWorkspace(oop) {};
    GenieSpectrum(const GenieSpectrum& gs) : GenieWorkspace(gs) {};
    GenieSpectrum& operator=(GenieSpectrum& gs) { return (GenieWorkspace::operator=(gs), *this); }
    GenieSpectrum& operator+=(const GenieSpectrum& gs);
};

//GenieSpectrum::operator+(GenieSpectrum& gs1, GenieSpectrum& gs2);

#endif /* GENIE_SPECTRUM */
