/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef GENIE_STRING_ARRAY
#define GENIE_STRING_ARRAY

#include "genie_array.h"

class GenieStringArray : public GenieArray<GenieString, g_string, GenieStringArrayType>
{
public:
    GenieStringArray(OOP oop = nilOOP) : GenieArray<GenieString, g_string, GenieStringArrayType>(oop) {}
    GenieStringArray(int dim1, int dim2 = 0) : GenieArray<GenieString, g_string, GenieStringArrayType>(dim1, dim2) {}
    GenieStringArray(const GenieStringArray& gia) : GenieArray<GenieString, g_string, GenieStringArrayType>(gia) {}
    ~GenieStringArray();
    virtual void alloc(const GenieArrayBase& gab) { GenieArray<GenieString, g_string, GenieStringArrayType>::alloc(gab); }
//    ostream& print(ostream& os, const char* note = 0) const { return os; }
//    void operator()(const int* ia, int length);
    GenieStringArray(const char* sa[], long length);
    GenieVariableType read(IntermediateFile* gif);
    GenieVariableType write(IntermediateFile* gif);
    GenieVariableType skip(IntermediateFile* gif);
    GenieVariableType readAscii(fstream& fs);
    GenieVariableType writeAscii(fstream& fs, int indent = 0);
};

#endif /* GENIE_STRING_ARRAY */
