/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"

 



#if defined(HAVE_LIBF2C)
#	define ismplx ismplx_
#	define gauss_elim gauss_elim__
#	define vcopy vcopy_
#elif defined(__unix)
#	define ismplx ismplx_
#	define gauss_elim gauss_elim_
#	define vcopy vcopy_
#endif

 

 






typedef int integer;
typedef char *address;
typedef short int shortint;
typedef float real;
typedef double doublereal;
typedef struct { real r, i; } complex;
typedef struct { doublereal r, i; } doublecomplex;
typedef int logical;
typedef short int shortlogical;
typedef char logical1;
typedef char integer1;
   




 




 







typedef int flag;
typedef int ftnlen;
typedef int ftnint;


 
typedef struct
{	flag cierr;
	ftnint ciunit;
	flag ciend;
	char *cifmt;
	ftnint cirec;
} cilist;

 
typedef struct
{	flag icierr;
	char *iciunit;
	flag iciend;
	char *icifmt;
	ftnint icirlen;
	ftnint icirnum;
} icilist;

 
typedef struct
{	flag oerr;
	ftnint ounit;
	char *ofnm;
	ftnlen ofnmlen;
	char *osta;
	char *oacc;
	char *ofm;
	ftnint orl;
	char *oblnk;
} olist;

 
typedef struct
{	flag cerr;
	ftnint cunit;
	char *csta;
} cllist;

 
typedef struct
{	flag aerr;
	ftnint aunit;
} alist;

 
typedef struct
{	flag inerr;
	ftnint inunit;
	char *infile;
	ftnlen infilen;
	ftnint	*inex;	 
	ftnint	*inopen;
	ftnint	*innum;
	ftnint	*innamed;
	char	*inname;
	ftnlen	innamlen;
	char	*inacc;
	ftnlen	inacclen;
	char	*inseq;
	ftnlen	inseqlen;
	char 	*indir;
	ftnlen	indirlen;
	char	*infmt;
	ftnlen	infmtlen;
	char	*inform;
	ftnint	informlen;
	char	*inunf;
	ftnlen	inunflen;
	ftnint	*inrecl;
	ftnint	*innrec;
	char	*inblank;
	ftnlen	inblanklen;
} inlist;



union Multitype {	 
	integer1 g;
	shortint h;
	integer i;
	 
	real r;
	doublereal d;
	complex c;
	doublecomplex z;
	};

typedef union Multitype Multitype;

 	 

struct Vardesc {	 
	char *name;
	char *addr;
	ftnlen *dims;
	int  type;
	};
typedef struct Vardesc Vardesc;

struct Namelist {
	char *name;
	Vardesc **vars;
	int nvars;
	};
typedef struct Namelist Namelist;








 




typedef int   (*U_fp)();
typedef shortint (*J_fp)();
typedef integer (*I_fp)();
typedef real (*R_fp)();
typedef doublereal (*D_fp)(), (*E_fp)();
typedef   void  (*C_fp)();
typedef   void  (*Z_fp)();
typedef logical (*L_fp)();
typedef shortlogical (*K_fp)();
typedef   void  (*H_fp)();
typedef   int (*S_fp)();

 
typedef void  C_f;	 
typedef void  H_f;	 
typedef void  Z_f;	 
typedef doublereal E_f;	 

 

























 

static integer c__9 = 9;
static integer c__1 = 1;
static real c_b19 = 0.f;

 

 
integer ismplx(real *par, real *dpar, real *covar, integer *np, logical *
	lchout, E_fp cchi, real *x, real *y, real *e, integer *n)
{
     

    static integer nmax = 50;

     
    static char fmt_100[] = "(\002 Chi-squared = \002,1pe12.4)";

     
    integer covar_dim1, covar_offset, ret_val, i__1;

     
     
    static real hess[2500];
    static integer indx[50];
    static real c__[51], v[2550], delta[50];
    extern   int ginfo_(char *, ftnlen);
    static real c0, c1[100]	 , c2[2500];
    extern   int vcopy(real *, real *, integer *), hsint1_(
	    real *, real *, real *, integer *, real *), hsint2_(real *, real *
	    , real *, real *, integer *, real *);
    static integer idflag, ir[51];
    static real ex[150], chimin;
    extern   int chinit_(E_fp, real *, integer *, real *, real 
	    *, real *, real *, real *, real *, real *, integer *, integer *); 
    static char string[72];
    extern   int invert_(real *, real *, integer *, integer *);
    static real chi;
    extern   int simplex_(real *, integer *, real *, real *, 
	    real *, integer *, integer *, E_fp, real *, real *, real *, 
	    integer *);

     
    static icilist io___3 = { 0, string, 0, 0, 72, 1 };
    static icilist io___6 = { 0, string, 0, fmt_100, 72, 1 };
    static icilist io___11 = { 0, string, 0, fmt_100, 72, 1 };


 

 


 
 
 
 

 
 
 
 
 
 
 
 
 
 
 
 

 
 
 
 
 

 
 
 

 


 
 
 
 
 
 
 
 
 
     
    covar_dim1 = *np;
    covar_offset = covar_dim1 + 1;
    covar -= covar_offset;
    --dpar;
    --par;
    --e;
    --y;
    --x;

     

 
    ret_val = -1;

    if ( *np > nmax ) {

	gprintef("Simplex error: Too many variables to solve\n");
 
	return ret_val;
 
    }
 
    vcopy(&par[1], v, np);
 
    chimin = (*cchi)(v, np, &x[1], &y[1], &e[1], n);
 
    if (*lchout) {
 
	gprintdf("%s\n", string);
 
    }
 
L1:
    i__1 = *np * 1000;
    simplex_(v, np, &dpar[1], ex, c__, ir, &i__1, (E_fp)cchi, &x[1], &y[1], &
	    e[1], n);
 
    vcopy(ex, v, np);
 
    chi = (*cchi)(v, np, &x[1], &y[1], &e[1], n);
 
    if (*lchout) {
 
	gprintdf("%s\n", string);
 
    }
 
    if (1.f - chi / chimin > 1e-4f) {
 
	chimin = chi;
 
	goto L1;
 
    }
 
    vcopy(v, &par[1], np);
 
    chinit_((E_fp)cchi, v, np, delta, &c0, c1, c2, &x[1], &y[1], &e[1], n, &
	    idflag);
 
    if (idflag > 0) {
 
	hsint1_(&c0, c1, delta, np, hess);
 
	hsint2_(&c0, c1, c2, delta, np, hess);
 
	invert_(hess, &covar[covar_offset], np, indx);
 
	ret_val = 1;
 
    }
 
    return ret_val;
}  


 

 
  int vcopy(real *x, real *y, integer *n)
{
     
    integer i__1;

     
    static integer i__;

 

 

 
     
    --y;
    --x;

     
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
 
 
	y[i__] = x[i__];
    }
 
    return 0;
}  


 
  int vrfill_(real *x, real *a, integer *n)
{
     
    integer i__1;

     
    static integer i__;

 

 

 
     
    --x;

     
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
 
 
	x[i__] = *a;
    }
 
    return 0;
}  


 

 
  int simplex_(real *v, integer *np, real *d__, real *ex, real 
	*c__, integer *ir, integer *mx, E_fp cchi, real *x, real *y, real *e, 
	integer *n)
{
     

    static real alpha = 1.f;
    static real beta = .5f;
    static real gama = 2.f;

     
    integer v_dim1, v_offset, ex_dim1, ex_offset, i__1;

     
    static real caim, cmin;
    static integer iter;
    static real drop;
    static logical slow;
    extern   int contract_(E_fp, real *, real *, real *, real *
	    , real *, real *, real *, real *, real *, integer *, real *, real 
	    *, real *, integer *), cont2_(E_fp, integer *, real *, real *, 
	    integer *, integer *, real *, real *, real *, integer *), simp0_(
	    E_fp, real *, real *, real *, integer *, integer *, real *, real *
	    , real *, integer *), xcent_(real *, real *, integer *, integer *)
	    ;
    static real c0;
    extern   int vcopy(real *, real *, integer *), xzero_(
	    real *, real *, real *, integer *, real *), ssort_(real *, 
	    integer *, integer *);
    static real c00, ch;
    static integer id;
    static real cl, cs;
    extern   int expand_(E_fp, real *, real *, real *, real *, 
	    integer *, real *, real *, real *, real *, real *, integer *);
    static integer noluck;
    extern   int vrfill_(real *, real *, integer *);
    static integer np3, irstrt;

 

 
 
 
 
 
     
    ex_dim1 = *np;
    ex_offset = ex_dim1 + 1;
    ex -= ex_offset;
    v_dim1 = *np;
    v_offset = v_dim1 + 1;
    v -= v_offset;
    --d__;
    --c__;
    --ir;
    --x;
    --y;
    --e;

     

 
    slow = (0) ;
 
    np3 = *np * 3;
 
    caim = 0.f;
 
    c__[1] = (*cchi)(&v[v_dim1 + 1], np, &x[1], &y[1], &e[1], n);
 
    simp0_((E_fp)cchi, &v[v_offset], &d__[1], &c__[1], &ir[1], np, &x[1], &y[
	    1], &e[1], n);
 
    cmin = c__[ir[*np + 1]];

 
    iter = 0;
 
    noluck = 0;
 
    irstrt = 0;
 
L10:
    ++iter;
 
    ++noluck;
 
    if (iter >= *mx || noluck > 100) {
 
	ssort_(&c__[1], &ir[1], np);
 
	vcopy(&v[ir[*np + 1] * v_dim1 + 1], &ex[ex_offset], np);
 
	if (iter < 250) {
 
	    noluck = 0;
 
	    i__1 = *np;
	    for (id = 1; id <= i__1; ++id) {
 
 
		d__[id] /= 10.f;
	    }
 
	    vcopy(&ex[ex_offset], &v[v_offset], np);
 
	    c__[1] = (*cchi)(&v[v_dim1 + 1], np, &x[1], &y[1], &e[1], n);
 
	    simp0_((E_fp)cchi, &v[v_offset], &d__[1], &c__[1], &ir[1], np, &x[
		    1], &y[1], &e[1], n);
 
	    cmin = c__[ir[*np + 1]];
 
	} else {
 
	    return 0;
 
	}
 
    }
 
    vrfill_(&ex[ex_offset], &c_b19, &np3);
 
    xcent_(&v[v_offset], &ex[ex_dim1 * 3 + 1], &ir[1], np);
 
    xzero_(&v[ir[1] * v_dim1 + 1], &ex[ex_offset], &ex[ex_dim1 * 3 + 1], np, &
	    alpha);
 
    c0 = (*cchi)(&ex[ex_offset], np, &x[1], &y[1], &e[1], n);
 
    cl = c__[ir[*np + 1]];
 
    ch = c__[ir[1]];
 
    cs = c__[ir[2]];
 
    if (c0 < cl) {
 
	expand_((E_fp)cchi, &cl, &ex[ex_offset], &ex[(ex_dim1 << 1) + 1], &ex[
		ex_dim1 * 3 + 1], np, &c0, &gama, &x[1], &y[1], &e[1], n);
 
    } else if (c0 > cs) {
 
	contract_((E_fp)cchi, &ch, &cs, &c0, &c00, &ex[ex_offset], &ex[(
		ex_dim1 << 1) + 1], &ex[ex_dim1 * 3 + 1], &v[ir[1] * v_dim1 + 
		1], &beta, np, &x[1], &y[1], &e[1], n);
 
	if (c00 < ch && c00 < c0) {
 
	    vcopy(&ex[(ex_dim1 << 1) + 1], &ex[ex_offset], np);
 
	    c0 = c00;
 
	} else {
 
	    cont2_((E_fp)cchi, &ir[*np + 1], &v[v_offset], &c__[1], np, &ir[1]
		    , &x[1], &y[1], &e[1], n);
 
	    ++irstrt;
 
	    if (c__[ir[*np + 1]] < cmin) {
		cmin = c__[ir[*np + 1]];
	    }
 
	    if (irstrt >= 5) {
 
		noluck = 0;
 
		ssort_(&c__[1], &ir[1], np);
 
		vcopy(&v[ir[*np + 1] * v_dim1 + 1], &ex[ex_offset], np);
 
		return 0;
 
	    }
 
	}
 
    }

 
    vcopy(&ex[ex_offset], &v[ir[1] * v_dim1 + 1], np);
 
    c__[ir[1]] = c0;
 
    ssort_(&c__[1], &ir[1], np);
 
    if (c__[ir[*np + 1]] < cmin) {
 
	drop = (cmin - c__[ir[*np + 1]]) / cmin;
 
	if ((doublereal)((  drop  ) >= 0 ? (  drop  ) : -(  drop  ))   < 1e-4f) {
	    slow = (1) ;
	}
 
	noluck = 0;
 
	cmin = c__[ir[*np + 1]];
 
    }
 
    if (cmin > caim && ! slow) {
	goto L10;
    }
 
    vcopy(&v[ir[*np + 1] * v_dim1 + 1], &ex[ex_offset], np);
 
    return 0;
}  


 
  int simp0_(E_fp cchi, real *v, real *d__, real *c__, integer 
	*ir, integer *np, real *x, real *y, real *e, integer *n)
{
     
    integer v_dim1, v_offset, i__1;

     
    static integer i__;
    extern   int vcopy(real *, real *, integer *), ssort_(
	    real *, integer *, integer *);

 

 
 
 

 
     
    --d__;
    --c__;
    --ir;
    v_dim1 = *np;
    v_offset = v_dim1 + 1;
    v -= v_offset;
    --x;
    --y;
    --e;

     
    i__1 = *np + 1;
    for (i__ = 2; i__ <= i__1; ++i__) {
 
	vcopy(&v[v_offset], &v[i__ * v_dim1 + 1], np);
 
	v[i__ - 1 + i__ * v_dim1] += d__[i__ - 1];
 
	c__[i__] = (*cchi)(&v[i__ * v_dim1 + 1], np, &x[1], &y[1], &e[1], n);
 
 
    }
 
    ssort_(&c__[1], &ir[1], np);
 
    return 0;
}  


 
  int ssort_(real *c__, integer *ir, integer *np)
{
     
    integer i__1, i__2, i__3;

     
    static integer i__, j, ii;

 

 
 

 
     
    --ir;
    --c__;

     
    ir[1] = 1;
 
    i__1 = *np + 1;
    for (j = 2; j <= i__1; ++j) {
 
	i__2 = j - 1;
	for (i__ = 1; i__ <= i__2; ++i__) {
 
	    if (c__[j] < c__[ir[i__]]) {
		goto L10;
	    }
 
	    i__3 = j - i__;
	    for (ii = 1; ii <= i__3; ++ii) {
 
 
		ir[j + 1 - ii] = ir[j - ii];
	    }
 
	    ir[i__] = j;
 
	    goto L20;
 
L10:
	    ;
	}
 
	ir[j] = j;
 
L20:
	;
    }
 
    return 0;
}  


 
  int xcent_(real *v, real *xc, integer *ih, integer *np)
{
     
    integer v_dim1, v_offset, i__1, i__2;

     
    static integer i__, j;
    static real xnorm;

 

 

 
     
    --xc;
    v_dim1 = *np;
    v_offset = v_dim1 + 1;
    v -= v_offset;

     
    xnorm = 1.f / (real) (*np);
 
    i__1 = *np + 1;
    for (j = 1; j <= i__1; ++j) {
 
	if (j == *ih) {
	    goto L20;
	}
 
	i__2 = *np;
	for (i__ = 1; i__ <= i__2; ++i__) {
 
 
	    xc[i__] += v[i__ + j * v_dim1];
	}
 
L20:
	;
    }
 
    i__1 = *np;
    for (i__ = 1; i__ <= i__1; ++i__) {
 
 
	xc[i__] *= xnorm;
    }
 
    return 0;
}  


 
  int xzero_(real *xh, real *x0, real *xc, integer *np, real *
	a)
{
     
    integer i__1;

     
    static integer i__;

 

 

 
     
    --xc;
    --x0;
    --xh;

     
    i__1 = *np;
    for (i__ = 1; i__ <= i__1; ++i__) {
 
 
	x0[i__] = *a * (xc[i__] - xh[i__]) + xc[i__];
    }
 
    return 0;
}  


 
  int expand_(E_fp cchi, real *cl, real *x0, real *x00, real *
	xc, integer *np, real *c0, real *g, real *x, real *y, real *e, 
	integer *n)
{
     
    integer i__1;

     
    static integer i__;
    extern   int vcopy(real *, real *, integer *);
    static real c00;

 

 
 

 
     
    --e;
    --y;
    --x;
    --xc;
    --x00;
    --x0;

     
    i__1 = *np;
    for (i__ = 1; i__ <= i__1; ++i__) {
 
 
	x00[i__] = *g * (x0[i__] - xc[i__]) + xc[i__];
    }
 
    c00 = (*cchi)(&x00[1], np, &x[1], &y[1], &e[1], n);
 
    if (c00 < *cl) {
 
	vcopy(&x00[1], &x0[1], np);
 
	*c0 = c00;
 
    }
 
    return 0;
}  


 
  int contract_(E_fp cchi, real *ch, real *cs, real *c0, real *
	c00, real *x0, real *x00, real *xc, real *xh, real *b, integer *np, 
	real *x, real *y, real *e, integer *n)
{
     
    integer i__1;

     
    static integer i__;

 

 
 

 
     
    --e;
    --y;
    --x;
    --xh;
    --xc;
    --x00;
    --x0;

     
    if (*c0 < *ch) {
 
	i__1 = *np;
	for (i__ = 1; i__ <= i__1; ++i__) {
 
 
	    x00[i__] = *b * (x0[i__] - xc[i__]) + xc[i__];
	}
 
    } else {
 
	i__1 = *np;
	for (i__ = 1; i__ <= i__1; ++i__) {
 
 
	    x00[i__] = *b * (xh[i__] - xc[i__]) + xc[i__];
	}
 
    }
 
    *c00 = (*cchi)(&x00[1], np, &x[1], &y[1], &e[1], n);
 
    return 0;
}  


 
  int cont2_(E_fp cchi, integer *k, real *v, real *c__, 
	integer *np, integer *ir, real *x, real *y, real *e, integer *n)
{
     
    integer v_dim1, v_offset, i__1, i__2;

     
    static integer i__, j;
    extern   int ssort_(real *, integer *, integer *);

 

 
 
 

 
     
    --c__;
    v_dim1 = *np;
    v_offset = v_dim1 + 1;
    v -= v_offset;
    --ir;
    --x;
    --y;
    --e;

     
    i__1 = *np + 1;
    for (j = 1; j <= i__1; ++j) {
 
	if (j == *k) {
	    goto L20;
	}
 
	i__2 = *np;
	for (i__ = 1; i__ <= i__2; ++i__) {
 
	    v[i__ + j * v_dim1] = (v[i__ + j * v_dim1] + v[i__ + *k * v_dim1])
		     * .5f;
 
	    c__[j] = (*cchi)(&v[j * v_dim1 + 1], np, &x[1], &y[1], &e[1], n);
 
 
	}
 
L20:
	;
    }
 
    ssort_(&c__[1], &ir[1], np);
 
    return 0;
}  


 

 
  int chinit_(E_fp cchi, real *v, integer *np, real *delta, 
	real *c0, real *c1, real *c2, real *x, real *y, real *e, integer *n, 
	integer *idflag)
{
     
    integer c2_dim1, c2_offset, i__1, i__2;

     
    static integer i__, j;
    static real cdelta;
    extern   int dlinit_(E_fp, integer *, real *, integer *, 
	    real *, real *, real *, real *, real *, real *, real *, real *, 
	    integer *, integer *), vrfill_(real *, real *, integer *);

 

 
 

 
     
    --v;
    c2_dim1 = *np;
    c2_offset = c2_dim1 + 1;
    c2 -= c2_offset;
    --delta;
    c1 -= 3;
    --x;
    --y;
    --e;

     
    *idflag = 1;
 
    i__1 = *np * *np;
    vrfill_(&c2[c2_offset], &c_b19, &i__1);
 
    *c0 = (*cchi)(&v[1], np, &x[1], &y[1], &e[1], n);
 
    cdelta = *c0 / 2e3f;
 
    if (cdelta < .5f) {
	cdelta = .5f;
    }
 
    i__1 = *np;
    for (i__ = 1; i__ <= i__1; ++i__) {
 
	dlinit_((E_fp)cchi, np, &v[1], &i__, &c1[(i__ << 1) + 1], &c1[(i__ << 
		1) + 2], c0, &cdelta, &delta[i__], &x[1], &y[1], &e[1], n, 
		idflag);
 
 
    }
 
    i__1 = *np;
    for (j = 1; j <= i__1; ++j) {
 
	v[j] += delta[j];
 
	i__2 = *np;
	for (i__ = j + 1; i__ <= i__2; ++i__) {
 
	    v[i__] += delta[i__];
 
	    c2[i__ + j * c2_dim1] = (*cchi)(&v[1], np, &x[1], &y[1], &e[1], n)
		    ;
 
	    c2[j + i__ * c2_dim1] = c2[i__ + j * c2_dim1];
 
	    v[i__] -= delta[i__];
 
 
	}
 
	v[j] -= delta[j];
 
 
    }
 
    return 0;
}  


 
  int dlinit_(E_fp cchi, integer *np, real *par, integer *j, 
	real *cminus, real *cplus, real *c0, real *cdelta, real *delta, real *
	x, real *y, real *e, integer *n, integer *idflag)
{
     

    static real frac = 1e-6f;
    static real small = 1e-20f;
    static real parbig = 1e20f;
    static real dbig = 1e12f;

     
    real r__1, r__2;

     
    static real d__;
    static integer i__;
    static real par0;

 

 
 
 
     
    --e;
    --y;
    --x;
    --par;

     

 
    par0 = par[*j];
 
    d__ = frac * (doublereal)((  par0  ) >= 0 ? (  par0  ) : -(  par0  ))   + small;
 
    for (i__ = 1; i__ <= 100; ++i__) {
 
	d__ += d__;
 
	par[*j] = par0 - d__;
 
	*cminus = (*cchi)(&par[1], np, &x[1], &y[1], &e[1], n);
 
	par[*j] = par0 + d__;
 
	*cplus = (*cchi)(&par[1], np, &x[1], &y[1], &e[1], n);
 
	if (par[*j] > parbig || (r__1 = *cminus - *c0, (doublereal)((  r__1  ) >= 0 ? (  r__1  ) : -(  r__1  ))  ) > *cdelta 
		|| (r__2 = *cplus - *c0, (doublereal)((  r__2  ) >= 0 ? (  r__2  ) : -(  r__2  ))  ) > *cdelta) {
	    goto L1;
	}
 
	if (d__ > dbig) {
 
	    *idflag = -1;
 
	    return 0;
 
	}
 
 
    }
 
L1:
    *delta = d__;
 
    par[*j] = par0;
 
    return 0;
}  


 
  int hsint1_(real *c0, real *c1, real *d__, integer *np, real 
	*hs)
{
     
    integer hs_dim1, hs_offset, i__1;

     
    static integer i__;

 

 

 
     
    c1 -= 3;
    --d__;
    hs_dim1 = *np;
    hs_offset = hs_dim1 + 1;
    hs -= hs_offset;

     
    i__1 = *np;
    for (i__ = 1; i__ <= i__1; ++i__) {
 
 
	hs[i__ + i__ * hs_dim1] = (c1[(i__ << 1) + 2] - *c0 - *c0 + c1[(i__ <<
		 1) + 1]) / (d__[i__] * d__[i__]);
    }
 
    return 0;
}  


 
  int hsint2_(real *c0, real *c1, real *c2, real *d__, integer 
	*np, real *hs)
{
     
    integer c2_dim1, c2_offset, hs_dim1, hs_offset, i__1, i__2;

     
    static integer i__, j;

 

 

 
     
    c1 -= 3;
    --d__;
    hs_dim1 = *np;
    hs_offset = hs_dim1 + 1;
    hs -= hs_offset;
    c2_dim1 = *np;
    c2_offset = c2_dim1 + 1;
    c2 -= c2_offset;

     
    i__1 = *np;
    for (j = 1; j <= i__1; ++j) {
 
	i__2 = *np;
	for (i__ = j + 1; i__ <= i__2; ++i__) {
 
	    hs[i__ + j * hs_dim1] = (c2[i__ + j * c2_dim1] - c1[(i__ << 1) + 
		    2] - c1[(j << 1) + 2] + *c0) / (d__[i__] * d__[j]);
 
	    hs[j + i__ * hs_dim1] = hs[i__ + j * hs_dim1];
 
 
	}
 
 
    }
 
    return 0;
}  


 
  int invert_(real *hess, real *covar, integer *np, integer *
	indx)
{

     
    integer hess_dim1, hess_offset, covar_dim1, covar_offset, i__1;

     
    static integer i__;
    extern   int vrfill_(real *, real *, integer *), 
	    gauss_elim(real *, integer *, integer *, real *, integer *, 
	    integer *);

 

 
 
 
     
    covar_dim1 = *np;
    covar_offset = covar_dim1 + 1;
    covar -= covar_offset;
    hess_dim1 = *np;
    hess_offset = hess_dim1 + 1;
    hess -= hess_offset;
    --indx;

     

 
    i__1 = *np * *np;
    vrfill_(&covar[covar_offset], &c_b19, &i__1);
 
    i__1 = *np;
    for (i__ = 1; i__ <= i__1; ++i__) {
 
 
	covar[i__ + i__ * covar_dim1] = 2.f;
    }
 
    gauss_elim(&hess[hess_offset], np, np, &covar[covar_offset], np, np);
 
    return 0;
}  

