/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef HDF_DFSD
#define HDF_DFSD

#include "hdf_object.h"

class DFSD : public HDFObject
{
    protected:
	intn m_rank;						// number or dimensions
	void* m_data;						// data to read/write
	int32* m_dims_sizes;					// sizes of dimensions
	int32 m_type;						// type of "data"
	char* m_label;
	char* m_unit;
	char* m_format;
	char* m_coordsys;
	int readAttributes();
	int writeAttributes();

    public:
	DFSD(HDFFile& hdf, uint16 ref = INVALID_REF);			// constructor for a "Read"
	DFSD(HDFFile& hdf, int32 type, int32 rank, int32* dims_sizes, void* data, uint16 ref = INVALID_REF); // constructor for a "write"
	ostream& print(ostream& os) const;
	int writeToFile();
	int readFromFile();
	static int numberInFile(HDFFile& hdf);
	static int rewind(HDFFile& hdf);
};

inline ostream& operator<<(ostream& os, const DFSD& dfsd)
{
    return dfsd.print(os);
}

#endif /* HDF_DFSD */

