/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include "int_convert.h"

/*
 * Byte swaps for int and short
 */

static const char* rcsid = "@(#)$Id: int_convert.c,v 1.2 1997/01/02 11:39:42 faa Exp $";
USE_RCSID(rcsid);

#if 0
inline unsigned swap_int(unsigned a)
{
    union { unsigned u; unsigned char c[4]; } temp;
    unsigned char ctemp;
    temp.u = a;
    ctemp = temp.c[0]; temp.c[0] = temp.c[3]; temp.c[3] = ctemp; 
    ctemp = temp.c[1]; temp.c[1] = temp.c[2]; temp.c[2] = ctemp; 
    return temp.u;
}
#endif

#define swap_int(a) ( ((a) << 24) | \
                      (((a) << 8) & 0x00ff0000) | \
                      (((a) >> 8) & 0x0000ff00) | \
        	      ((unsigned long)(a) >>24) )

#define swap_short(a) ( ((a & 0xff) << 8) | ((unsigned short)(a) >> 8) )

/* VAXes are little endian */

unsigned short local_to_vax_short(const unsigned short* s)
{
#if defined(WORDS_BIGENDIAN)
    return swap_short(*s);
#else 
    return *s;
#endif /* WORDS_BIGENDIAN */
}

unsigned short vax_to_local_short(const unsigned short* s)
{
#if defined(WORDS_BIGENDIAN)
    return swap_short(*s);
#else
    return *s;
#endif /* WORDS_BIGENDIAN */
}

unsigned local_to_vax_int(const unsigned* i)
{
#if defined(WORDS_BIGENDIAN)
    return swap_int(*i);
#else
    return *i;
#endif /* WORDS_BIGENDIAN */
}

unsigned vax_to_local_int(const unsigned* i)
{
#if defined(WORDS_BIGENDIAN)
    return swap_int(*i);
#else
    return *i;
#endif /* WORDS_BIGENDIAN */
}

void local_to_vax_shorts(unsigned short* sa, const int* n)
{
#if defined(WORDS_BIGENDIAN)
    int i;
    for(i=0; i<*n; i++)
    {
	sa[i] = swap_short(sa[i]);
    }
#endif /* WORDS_BIGENDIAN */
    return;
}

void vax_to_local_shorts(unsigned short* sa, const int* n)
{
#if defined(WORDS_BIGENDIAN)
    int i;
    for(i=0; i<*n; i++)
    {
	sa[i] = swap_short(sa[i]);
    }
#endif /* WORDS_BIGENDIAN */
    return;
}

void local_to_vax_ints(unsigned* ia, const int* n)
{
#if defined(WORDS_BIGENDIAN)
    int i;
    for(i=0; i<*n; i++)
    {
	ia[i] = swap_int(ia[i]);
    }
#endif /* WORDS_BIGENDIAN */
    return;
}

void vax_to_local_ints(unsigned* ia, const int* n)
{
#if defined(WORDS_BIGENDIAN)
    int i;
    for(i=0; i<*n; i++)
    {
	ia[i] = swap_int(ia[i]);
    }
#endif /* WORDS_BIGENDIAN */
    return;
}

