C   Open GENIE, a program for neutron scattering data analysis & display
C   ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
C   Copyright (C) 1996,1997
C
C   This program is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C
C
C	Module: 	IOLINK
C	Author:		Freddie Akeroyd, ISIS
C	Purpose:	Provide intermediate layer between FORTRAN IO and C++ routines
C			Mostly it handles the translating of character variables
C
C	$Id: iolink.f,v 1.17 1997/02/21 10:44:09 faa Exp $
C
        SUBROUTINE GETDAT_(IRUNID,IFSN,NOS,IDATA,LENGTH,ERRCODE)
        IMPLICIT NONE
        INTEGER*4 IFSN,NOS,LENGTH,ERRCODE,IDATA(*),IRUNID(*)
        CHARACTER*512	EXTRACT_STRING
	CHARACTER*60	RUNID
	RUNID=' '
	RUNID=EXTRACT_STRING(IRUNID(2),IRUNID(1))
        CALL GETDAT(RUNID,IFSN,NOS,IDATA,LENGTH,ERRCODE)
	RETURN
	END
C
        SUBROUTINE OPEN_DATA_FILE_(S1,I1,I2,I3,I4)
        IMPLICIT NONE
        INTEGER*4 I1,I2,I3,I4
        CHARACTER*512	EXTRACT_STRING
	CHARACTER*60	FILENAME
        INTEGER*4 S1(*)
	FILENAME=' '
	FILENAME=EXTRACT_STRING(S1(2),S1(1))
        CALL OPEN_DATA_FILE(FILENAME, I1, I2, I3,I4)
	RETURN
        END
C
      SUBROUTINE READ_DATA_(IRUNID,ERRCODE,ISPEC,DELT_WORK,SPEC_WORK,
     +                      TTHE_WORK,
     +                      L2_WORK,NDETMAX,TCB,IDAT,NTCMAX,L1,L2,
     +                      TTHE,DELT,PHI,IRUN_TITLE,DURATION,
     +                      ICOMB_TIME,IUSER_NAME,IINST_NAME,IRUN_NO,
     +			    USER_TABLES,NUSE,QUICK)
        IMPLICIT NONE
        INTEGER*4 NDETMAX,NTCMAX,IDAT(NTCMAX),ERRCODE,ISPEC,ITEMP
        INTEGER*4 SPEC_WORK(NDETMAX),I,J,QUICK,NUSE
	INTEGER*4 IRUNID(*),IRUN_TITLE(*),ICOMB_TIME(*),
     +          IUSER_NAME(*),IINST_NAME(*),IRUN_NO(*)
        REAL*4 DELT_WORK(NDETMAX),L2_WORK(NDETMAX),TTHE_WORK(NDETMAX)
        REAL*4 TCB(NTCMAX),DURATION,USER_TABLES(NUSE)
        REAL*4 TTHE,L2,DELT
        REAL*4 L1,PHI
	BYTE B(4)
	EQUIVALENCE (ITEMP,B(1))
C
        CHARACTER*512 EXTRACT_STRING
	CHARACTER*60 RUNID
	CHARACTER*80 RUN_TITLE
	CHARACTER*8 INST_NAME
	CHARACTER*20 USER_NAME
	CHARACTER*21 COMB_TIME
	CHARACTER*5 RUN_NO

	RUNID = EXTRACT_STRING(IRUNID(2), IRUNID(1))
	RUN_TITLE = EXTRACT_STRING(IRUN_TITLE(2), IRUN_TITLE(1))
	COMB_TIME = EXTRACT_STRING(ICOMB_TIME(2), ICOMB_TIME(1))
	USER_NAME = EXTRACT_STRING(IUSER_NAME(2), IUSER_NAME(1))
	INST_NAME = EXTRACT_STRING(IINST_NAME(2), IINST_NAME(1))
	RUN_NO = EXTRACT_STRING(IRUN_NO(2), IRUN_NO(1))

	CALL READ_DATA(RUNID,ERRCODE,ISPEC,DELT_WORK,SPEC_WORK,
     +                 TTHE_WORK,
     +                 L2_WORK,NDETMAX,TCB,IDAT,NTCMAX,L1,L2,
     +                 TTHE,DELT,PHI,RUN_TITLE,DURATION,
     +                 COMB_TIME,USER_NAME,INST_NAME,RUN_NO,
     +		       USER_TABLES,NUSE,QUICK)
	CALL REPLACE_STRING(RUN_TITLE,80,IRUN_TITLE)
	CALL REPLACE_STRING(COMB_TIME,21,ICOMB_TIME)
	CALL REPLACE_STRING(USER_NAME,20,IUSER_NAME)
	CALL REPLACE_STRING(INST_NAME,8,IINST_NAME)
	CALL REPLACE_STRING(RUN_NO,5,IRUN_NO)
	RETURN
	END
C
	SUBROUTINE DEFAULT_FILE_NAME_(IUNIT, IFILE)
	IMPLICIT NONE
	INTEGER*4 IUNIT, IFILE(*)
	CHARACTER*80 FILE
        CHARACTER*512 EXTRACT_STRING
	FILE = ' '
	FILE = EXTRACT_STRING(IFILE(2), IFILE(1))
	CALL DEFAULT_FILE_NAME(IUNIT, FILE)
	CALL REPLACE_STRING(FILE, 80, IFILE)
	RETURN
	END
C
	SUBROUTINE TRAN_OUT_(ntc, ntcmax, x_data_r, y_data_r, e_data_r, 
     1		 ixcaption, iycaption, irun_title, delt, inst_code, iinst_name,
     2		 xcode, ycode, l1, l2, tthe, ispec, irun_no, iuser_name,
     3		 duration, icomb_time, fi, user_par, st_var, ihistory,ierror)
	IMPLICIT NONE
	INTEGER*4 NTC,NTCMAX,INST_CODE,XCODE,YCODE,ISPEC,IRUN_NO,IERROR
	INTEGER*4 IXCAPTION(*),IYCAPTION(*),IRUN_TITLE(*),IINST_NAME(*),
     1          IUSER_NAME(*),ICOMB_TIME(*),IHISTORY(*)
	REAL*4 X_DATA_R(*),Y_DATA_R(*),E_DATA_R(*),DELT,L1,L2,TTHE,
     1       DURATION,FI,USER_PAR(30),ST_VAR(20)
	CHARACTER*200 HISTORY
	CHARACTER*80 RUN_TITLE
	CHARACTER*40 XCAPTION,YCAPTION
	CHARACTER*20 USER_NAME,COMB_TIME
	CHARACTER*8 INST_NAME
        CHARACTER*512 EXTRACT_STRING
	HISTORY=EXTRACT_STRING(IHISTORY(2),IHISTORY(1))
	RUN_TITLE=EXTRACT_STRING(IRUN_TITLE(2),IRUN_TITLE(1))
	XCAPTION=EXTRACT_STRING(IXCAPTION(2),IXCAPTION(1))
	YCAPTION=EXTRACT_STRING(IYCAPTION(2),IYCAPTION(1))
	USER_NAME=EXTRACT_STRING(IUSER_NAME(2),IUSER_NAME(1))
	COMB_TIME=EXTRACT_STRING(ICOMB_TIME(2),ICOMB_TIME(1))
	INST_NAME=EXTRACT_STRING(IINST_NAME(2),IINST_NAME(1))
	CALL TRAN_OUT(ntc, ntcmax, x_data_r, y_data_r, e_data_r, xcaption, 
     1		 ycaption, run_title, delt, inst_code, inst_name, xcode,
     2		 ycode, l1, l2, tthe, ispec, irun_no, user_name,
     3		 duration, comb_time, fi, user_par, st_var, history, ierror)
	CALL REPLACE_STRING(HISTORY, 200, IHISTORY)
	CALL REPLACE_STRING(RUN_TITLE, 80, IRUN_TITLE)
	CALL REPLACE_STRING(XCAPTION, 40, IXCAPTION)
	CALL REPLACE_STRING(YCAPTION, 40, IYCAPTION)
	CALL REPLACE_STRING(USER_NAME, 20, IUSER_NAME)
	CALL REPLACE_STRING(COMB_TIME, 20, ICOMB_TIME)
	CALL REPLACE_STRING(INST_NAME, 8, IINST_NAME)
	RETURN
	END
C
	SUBROUTINE TRAN_IN_(ntc, ntcmax, x_data_r, y_data_r, e_data_r,
     1		 ixcaption, iycaption, irun_title, delt, inst_code, iinst_name,
     2		 xcode, ycode, l1, l2, tthe, ispec, irun_no, iuser_name,
     3		 duration, icomb_time, fi, user_par, st_var, ihistory, ierror)
	IMPLICIT NONE
	INTEGER*4 NTC,NTCMAX,INST_CODE,XCODE,YCODE,ISPEC,IRUN_NO,IERROR
	INTEGER*4 IXCAPTION(*),IYCAPTION(*),IRUN_TITLE(*),IINST_NAME(*),
     1          IUSER_NAME(*),ICOMB_TIME(*),IHISTORY(*)
	REAL*4 X_DATA_R(*),Y_DATA_R(*),E_DATA_R(*),DELT,L1,L2,TTHE,
     1       DURATION,FI,USER_PAR(30),ST_VAR(20)
	CHARACTER*200 HISTORY
	CHARACTER*80 RUN_TITLE
	CHARACTER*40 XCAPTION,YCAPTION
	CHARACTER*20 USER_NAME,COMB_TIME
	CHARACTER*8 INST_NAME
        CHARACTER*512 EXTRACT_STRING
	HISTORY=EXTRACT_STRING(IHISTORY(2),IHISTORY(1))
	RUN_TITLE=EXTRACT_STRING(IRUN_TITLE(2),IRUN_TITLE(1))
	XCAPTION=EXTRACT_STRING(IXCAPTION(2),IXCAPTION(1))
	YCAPTION=EXTRACT_STRING(IYCAPTION(2),IYCAPTION(1))
	USER_NAME=EXTRACT_STRING(IUSER_NAME(2),IUSER_NAME(1))
	COMB_TIME=EXTRACT_STRING(ICOMB_TIME(2),ICOMB_TIME(1))
	INST_NAME=EXTRACT_STRING(IINST_NAME(2),IINST_NAME(1))
	CALL TRAN_IN(ntc, ntcmax, x_data_r, y_data_r, e_data_r, xcaption, 
     1		 ycaption, run_title, delt, inst_code, inst_name, xcode,
     2		 ycode, l1, l2, tthe, ispec, irun_no, user_name,
     3		 duration, comb_time, fi, user_par, st_var, history, ierror)
	CALL REPLACE_STRING(HISTORY, 200, IHISTORY)
	CALL REPLACE_STRING(RUN_TITLE, 80, IRUN_TITLE)
	CALL REPLACE_STRING(XCAPTION, 40, IXCAPTION)
	CALL REPLACE_STRING(YCAPTION, 40, IYCAPTION)
	CALL REPLACE_STRING(USER_NAME, 20, IUSER_NAME)
	CALL REPLACE_STRING(COMB_TIME, 20, ICOMB_TIME)
	CALL REPLACE_STRING(INST_NAME, 8, IINST_NAME)
	RETURN
	END
C
	SUBROUTINE READ_INT_(IUNIT,IFILENAME,LENNAME,IBLOCK,XARRAY,YARRAY,
     1                      EARRAY,NO_OF_SPECTRA,NO_SPECTRUM,NPT,DELTA,
     2			    RUN_NUMBER,XCODE,
     3                      YCODE,E_MODE,FI,L1,L2,E_FIXED,TTHET,
     4			    RUN_DURATION,IINST_NAME,ILONG_TITLE,
     5			    IRUN_USER,ISTART_TIME,IWS_HISTORY,
     6			    IXCAPTION,IYCAPTION,IMODE,USER_PAR,IERROR)
	IMPLICIT NONE
	INTEGER*4 IFILENAME(*),IINST_NAME(*),ILONG_TITLE(*),IRUN_USER(*),
     1		ISTART_TIME(*),IWS_HISTORY(*),IXCAPTION(*),
     2		IYCAPTION(*)
	INTEGER*4 IUNIT,NO_OF_SPECTRA,NO_SPECTRUM,XCODE,YCODE,
     1		RUN_NUMBER,E_MODE,IERROR,NPT,LENNAME,IBLOCK,IMODE
	REAL*4 XARRAY(NPT+1), YARRAY(NPT), EARRAY(NPT)
	REAL*4 DELTA,FI,L1,L2,E_FIXED,TTHET,RUN_DURATION
	REAL*4 USER_PAR(30)
	CHARACTER*80 FILENAME
	CHARACTER*200 WS_HISTORY
	CHARACTER*80 LONG_TITLE
	CHARACTER*8 INST_NAME
	CHARACTER*20 RUN_USER, START_TIME
	CHARACTER*40 XCAPTION, YCAPTION
	CHARACTER*512 EXTRACT_STRING
	FILENAME=' '
	FILENAME=EXTRACT_STRING(IFILENAME(2),IFILENAME(1))
	WS_HISTORY=EXTRACT_STRING(IWS_HISTORY(2),IWS_HISTORY(1))
	LONG_TITLE=EXTRACT_STRING(ILONG_TITLE(2),ILONG_TITLE(1))
	RUN_USER=EXTRACT_STRING(IRUN_USER(2),IRUN_USER(1))
	START_TIME=EXTRACT_STRING(ISTART_TIME(2),ISTART_TIME(1))
	XCAPTION=EXTRACT_STRING(IXCAPTION(2),IXCAPTION(1))
	YCAPTION=EXTRACT_STRING(IYCAPTION(2),IYCAPTION(1))
	INST_NAME=EXTRACT_STRING(IINST_NAME(2),IINST_NAME(1))
	CALL READ_INT(IUNIT,FILENAME,LENNAME,IBLOCK,XARRAY,YARRAY,
     1                EARRAY,NO_OF_SPECTRA,NO_SPECTRUM,NPT,DELTA,
     2			    RUN_NUMBER,XCODE,
     3                      YCODE,E_MODE,FI,L1,L2,E_FIXED,TTHET,
     4			    RUN_DURATION,INST_NAME,LONG_TITLE,
     5			    RUN_USER,START_TIME,WS_HISTORY,
     6			    XCAPTION,YCAPTION,IMODE,USER_PAR,IERROR)
	CALL REPLACE_STRING(FILENAME, 80, IFILENAME)
	CALL REPLACE_STRING(XCAPTION, 40, IXCAPTION)
	CALL REPLACE_STRING(YCAPTION, 40, IYCAPTION)
	CALL REPLACE_STRING(WS_HISTORY, 200, IWS_HISTORY)
	CALL REPLACE_STRING(RUN_USER, 20, IRUN_USER)
	CALL REPLACE_STRING(LONG_TITLE, 20, ILONG_TITLE)
	CALL REPLACE_STRING(START_TIME, 20, ISTART_TIME)
	CALL REPLACE_STRING(INST_NAME, 8, IINST_NAME)
	RETURN
	END
C
	SUBROUTINE LOAD_OUT_(IINFILETEM, IERROR)
	IMPLICIT NONE
	INTEGER IERROR
	CHARACTER*40 INFILETEM
	CHARACTER*512 EXTRACT_STRING
	INTEGER IINFILETEM(*)
	INFILETEM = ' '
	INFILETEM = EXTRACT_STRING(IINFILETEM(2), IINFILETEM(1))
	CALL LOAD_OUT(INFILETEM, IERROR)
	CALL REPLACE_STRING(INFILETEM, 40, IINFILETEM)
	RETURN
	END
C
	subroutine load_in_(lpt,x,y,e,
     +		ixcaption,iycaption,irun_title,
     +		delta,inst_code,iinst_name,
     +		xcode,ycode,L1,L2,tthet,
     +		ispec,run_number,iuser_name,
     +		duration,icomb_time,fi,
     +		user_par,st_var,ihistory,ierror)
	IMPLICIT NONE
	INTEGER*4 LPT,INST_CODE,XCODE,YCODE,ISPEC,run_number,IERROR
	INTEGER*4 IXCAPTION(*),IYCAPTION(*),IRUN_TITLE(*),IINST_NAME(*),
     1          IUSER_NAME(*),ICOMB_TIME(*),IHISTORY(*)
	REAL*4 X(*),Y(*),E(*),DELTA,L1,L2,TTHET,
     1       DURATION,FI,USER_PAR(30),ST_VAR(20)
	CHARACTER*200 HISTORY
	CHARACTER*80 RUN_TITLE
	CHARACTER*40 XCAPTION,YCAPTION
	CHARACTER*20 USER_NAME,COMB_TIME
	CHARACTER*8 INST_NAME
        CHARACTER*512 EXTRACT_STRING
	HISTORY=EXTRACT_STRING(IHISTORY(2),IHISTORY(1))
	RUN_TITLE=EXTRACT_STRING(IRUN_TITLE(2),IRUN_TITLE(1))
	XCAPTION=EXTRACT_STRING(IXCAPTION(2),IXCAPTION(1))
	YCAPTION=EXTRACT_STRING(IYCAPTION(2),IYCAPTION(1))
	USER_NAME=EXTRACT_STRING(IUSER_NAME(2),IUSER_NAME(1))
	COMB_TIME=EXTRACT_STRING(ICOMB_TIME(2),ICOMB_TIME(1))
	INST_NAME=EXTRACT_STRING(IINST_NAME(2),IINST_NAME(1))
	call load_in(lpt,x,y,e,
     +		xcaption,ycaption,run_title,
     +		delta,inst_code,inst_name,
     +		xcode,ycode,L1,L2,tthet,
     +		ispec,run_number,user_name,
     +		duration,comb_time,fi,
     +		user_par,st_var,history,ierror)
	CALL REPLACE_STRING(HISTORY, 200, IHISTORY)
	CALL REPLACE_STRING(RUN_TITLE, 80, IRUN_TITLE)
	CALL REPLACE_STRING(XCAPTION, 40, IXCAPTION)
	CALL REPLACE_STRING(YCAPTION, 40, IYCAPTION)
	CALL REPLACE_STRING(USER_NAME, 20, IUSER_NAME)
	CALL REPLACE_STRING(COMB_TIME, 20, ICOMB_TIME)
	CALL REPLACE_STRING(INST_NAME, 8, IINST_NAME)
	RETURN
	END
C
	subroutine func_in_(lpt,y,e,
     +		ixcaption,iycaption,irun_title,
     +		xcode,ycode,
     +		user_par,st_var,
     +		ihistory,ierror)
	INTEGER*4 LPT,XCODE,YCODE,ISPEC,IRUN_NO,IERROR
	INTEGER*4 IXCAPTION(*),IYCAPTION(*),IRUN_TITLE(*),
     1          IHISTORY(*)
	REAL*4 Y(*),E(*),DELT,L1,L2,TTHE,
     1       FI,USER_PAR(30),ST_VAR(20)
	CHARACTER*200 HISTORY
	CHARACTER*80 RUN_TITLE
	CHARACTER*40 XCAPTION,YCAPTION
        CHARACTER*512 EXTRACT_STRING
	HISTORY=EXTRACT_STRING(IHISTORY(2),IHISTORY(1))
	RUN_TITLE=EXTRACT_STRING(IRUN_TITLE(2),IRUN_TITLE(1))
	XCAPTION=EXTRACT_STRING(IXCAPTION(2),IXCAPTION(1))
	YCAPTION=EXTRACT_STRING(IYCAPTION(2),IYCAPTION(1))
	call func_in(lpt,y,e,
     +		xcaption,ycaption,run_title,
     +		xcode,ycode,
     +		user_par,st_var,
     +		history,ierror)
	CALL REPLACE_STRING(HISTORY, 200, IHISTORY)
	CALL REPLACE_STRING(RUN_TITLE, 80, IRUN_TITLE)
	CALL REPLACE_STRING(XCAPTION, 40, IXCAPTION)
	CALL REPLACE_STRING(YCAPTION, 40, IYCAPTION)
	RETURN
	END
C
	subroutine func_out_(lpt,x,y,e,
     +		ixcaption,iycaption,irun_title,
     +		L1,L2,tthet,fi,delta,
     +	       	user_par,st_var,
     +		xcode,ycode,ihistory,ierror)
	INTEGER*4 XCODE,YCODE,ISPEC,IRUN_NO,IERROR
	INTEGER*4 IXCAPTION(*),IYCAPTION(*),IRUN_TITLE(*),
     1          IHISTORY(*)
	REAL*4 X(*),Y(*),E(*),DELT,L1,L2,TTHE,
     1       DURATION,FI,USER_PAR(30),ST_VAR(20)
	CHARACTER*200 HISTORY
	CHARACTER*80 RUN_TITLE
	CHARACTER*40 XCAPTION,YCAPTION
        CHARACTER*512 EXTRACT_STRING
	HISTORY=EXTRACT_STRING(IHISTORY(2),IHISTORY(1))
	RUN_TITLE=EXTRACT_STRING(IRUN_TITLE(2),IRUN_TITLE(1))
	XCAPTION=EXTRACT_STRING(IXCAPTION(2),IXCAPTION(1))
	YCAPTION=EXTRACT_STRING(IYCAPTION(2),IYCAPTION(1))
	call func_out(lpt,x,y,e,
     +		xcaption,ycaption,run_title,
     +		L1,L2,tthet,fi,delta,
     +	       	user_par,st_var,
     +		xcode,ycode,history,ierror)
	CALL REPLACE_STRING(HISTORY, 200, IHISTORY)
	CALL REPLACE_STRING(RUN_TITLE, 80, IRUN_TITLE)
	CALL REPLACE_STRING(XCAPTION, 40, IXCAPTION)
	CALL REPLACE_STRING(YCAPTION, 40, IYCAPTION)
	RETURN
	END
C
	SUBROUTINE WRITE_INT_(IUNIT,IFILENAME,LENNAME,LEN_STREAMS,XARRAY,
     1               YARRAY,EARRAY,NO_OF_SPECTRA,NO_SPECTRUM,NPT,DELTA,
     2			    RUN_NUMBER,XCODE,
     3                      YCODE,E_MODE,FI,L1,L2,E_FIXED,TTHET,
     4			    RUN_DURATION,IINST_NAME,ILONG_TITLE,
     5			    IRUN_USER,ISTART_TIME,IWS_HISTORY,
     6			    IXCAPTION,IYCAPTION,IMODE,
     7			MINIMUM, IDAT_FILE, L_DAT_FILE, USER_PAR, IERROR)
	IMPLICIT NONE
	INTEGER*4 IFILENAME(*),IINST_NAME(*),ILONG_TITLE(*),IRUN_USER(*),
     1		ISTART_TIME(*),IWS_HISTORY(*),IXCAPTION(*),
     2		IYCAPTION(*),IDAT_FILE(*)
	INTEGER*4 IUNIT,NO_OF_SPECTRA,NO_SPECTRUM,XCODE,YCODE,
     1		RUN_NUMBER,E_MODE,IERROR,NPT,LENNAME,IBLOCK,IMODE
	INTEGER*4 LEN_STREAMS
	REAL*4 XARRAY(NPT+1), YARRAY(NPT), EARRAY(NPT), USER_PAR(30)
	REAL*4 DELTA,FI,L1,L2,E_FIXED,TTHET,RUN_DURATION
	INTEGER*4 MINIMUM, L_DAT_FILE
	CHARACTER*80 FILENAME
	CHARACTER*200 WS_HISTORY
	CHARACTER*75 DAT_FILE
	CHARACTER*80 LONG_TITLE
	CHARACTER*8 INST_NAME
	CHARACTER*20 RUN_USER, START_TIME
	CHARACTER*40 XCAPTION, YCAPTION
	CHARACTER*512 EXTRACT_STRING
	INTEGER TRUELEN
	EXTERNAL TRUELEN
C
	FILENAME=' '
	FILENAME=EXTRACT_STRING(IFILENAME(2),IFILENAME(1))
	WS_HISTORY=EXTRACT_STRING(IWS_HISTORY(2),IWS_HISTORY(1))
	LONG_TITLE=EXTRACT_STRING(ILONG_TITLE(2),ILONG_TITLE(1))
	RUN_USER=EXTRACT_STRING(IRUN_USER(2),IRUN_USER(1))
	START_TIME=EXTRACT_STRING(ISTART_TIME(2),ISTART_TIME(1))
	XCAPTION=EXTRACT_STRING(IXCAPTION(2),IXCAPTION(1))
	YCAPTION=EXTRACT_STRING(IYCAPTION(2),IYCAPTION(1))
	INST_NAME=EXTRACT_STRING(IINST_NAME(2),IINST_NAME(1))
	DAT_FILE=EXTRACT_STRING(IDAT_FILE(2),IDAT_FILE(1))
	L_DAT_FILE = TRUELEN(DAT_FILE)
	CALL WRITE_INT(IUNIT,FILENAME,LENNAME,LEN_STREAMS,XARRAY,
     1                      YARRAY,EARRAY,NO_OF_SPECTRA,NO_SPECTRUM,
     2			    NPT,DELTA,RUN_NUMBER,XCODE,
     3                      YCODE,E_MODE,FI,L1,L2,E_FIXED,TTHET,
     4			    RUN_DURATION,INST_NAME,LONG_TITLE,
     5			    RUN_USER,START_TIME,WS_HISTORY,
     6			    XCAPTION,YCAPTION,IMODE,MINIMUM,
     7			    DAT_FILE, L_DAT_FILE, USER_PAR, IERROR)
	CALL REPLACE_STRING(FILENAME, 80, IFILENAME)
	CALL REPLACE_STRING(XCAPTION, 40, IXCAPTION)
	CALL REPLACE_STRING(YCAPTION, 40, IYCAPTION)
	CALL REPLACE_STRING(WS_HISTORY, 200, IWS_HISTORY)
	CALL REPLACE_STRING(RUN_USER, 20, IRUN_USER)
	CALL REPLACE_STRING(LONG_TITLE, 20, ILONG_TITLE)
	CALL REPLACE_STRING(START_TIME, 20, ISTART_TIME)
	CALL REPLACE_STRING(INST_NAME, 8, IINST_NAME)
	CALL REPLACE_STRING(DAT_FILE, 75, IDAT_FILE)
	RETURN
	END
C
        SUBROUTINE GETPARI_(IRUNID,INAME,IVALUE,LENGTH_IN,
     1			    LENGTH_OUT,ERRCODE)
	IMPLICIT NONE
	INTEGER*4 LENGTH_IN, LENGTH_OUT, ERRCODE, IVALUE(LENGTH_IN), 
     1		  IRUNID(*), INAME(*)
        CHARACTER*512	EXTRACT_STRING
	CHARACTER*60	RUNID
	CHARACTER*10	NAME
	RUNID=' '
	NAME=' '
	RUNID=EXTRACT_STRING(IRUNID(2),IRUNID(1))
	NAME=EXTRACT_STRING(INAME(2),INAME(1))
        CALL GETPARI(RUNID,NAME,IVALUE,LENGTH_IN, LENGTH_OUT,ERRCODE)
	CALL REPLACE_STRING(RUNID, 60, IRUNID)
	CALL REPLACE_STRING(NAME, 10, INAME)
	RETURN
	END
C
        SUBROUTINE GETPARR_(IRUNID,INAME,RVALUE,LENGTH_IN,
     1  		    LENGTH_OUT,ERRCODE)
	IMPLICIT NONE
	INTEGER*4 LENGTH_IN, LENGTH_OUT, ERRCODE, IRUNID(*), INAME(*)
	REAL*4 	RVALUE(LENGTH_IN)
        CHARACTER*512	EXTRACT_STRING
	CHARACTER*60	RUNID
	CHARACTER*10	NAME
	RUNID=' '
	NAME=' '
	RUNID=EXTRACT_STRING(IRUNID(2),IRUNID(1))
	NAME=EXTRACT_STRING(INAME(2),INAME(1))
        CALL GETPARR(RUNID,NAME,RVALUE,LENGTH_IN,LENGTH_OUT,ERRCODE)
	CALL REPLACE_STRING(RUNID, 60, IRUNID)
	CALL REPLACE_STRING(NAME, 10, INAME)
	RETURN
	END
C
        SUBROUTINE GETPARC_(IRUNID,INAME,ICVALUE,LENGTH,ERRCODE)
	IMPLICIT NONE
	INTEGER*4 LENGTH, ERRCODE, IRUNID(*), INAME(*), ICVALUE(*)
        CHARACTER*512	EXTRACT_STRING
	CHARACTER*60	RUNID
	CHARACTER*10	NAME
	CHARACTER*512	CVALUE
	RUNID=' '
	NAME=' '
	CVALUE=' '
	RUNID=EXTRACT_STRING(IRUNID(2),IRUNID(1))
	NAME=EXTRACT_STRING(INAME(2),INAME(1))
	CVALUE=EXTRACT_STRING(ICVALUE(2),ICVALUE(1))
        CALL GETPARC(RUNID,NAME,CVALUE,LENGTH,ERRCODE)
	CALL REPLACE_STRING(RUNID, 60, IRUNID)
	CALL REPLACE_STRING(NAME, 10, INAME)
	CALL REPLACE_STRING(CVALUE, 512, ICVALUE)
	RETURN
	END
C
	SUBROUTINE MODULE_GET_INT(PARS_GET, NAME, VALUE)
	IMPLICIT NONE
	CHARACTER*(*) NAME
	INTEGER INAME(21)
	INTEGER VALUE
	EXTERNAL PARS_GET,REPLACE_STRING,G3_MODULE_GET_INT
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
	CALL G3_MODULE_GET_INT(PARS_GET, INAME, VALUE)
	RETURN
	END
C
	SUBROUTINE MODULE_GET_REAL(PARS_GET, NAME, VALUE)
	IMPLICIT NONE
	CHARACTER*(*) NAME
	INTEGER INAME(21)
	REAL VALUE
	EXTERNAL PARS_GET,REPLACE_STRING,G3_MODULE_GET_REAL
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
	CALL G3_MODULE_GET_REAL(PARS_GET, INAME, VALUE)
	RETURN
	END
C
	SUBROUTINE MODULE_GET_DOUBLE(PARS_GET, NAME, VALUE)
	IMPLICIT NONE
	CHARACTER*(*) NAME
	INTEGER INAME(21)
	DOUBLE PRECISION VALUE
	EXTERNAL PARS_GET,REPLACE_STRING,G3_MODULE_GET_DOUBLE
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
	CALL G3_MODULE_GET_DOUBLE(PARS_GET, INAME, VALUE)
	RETURN
	END
C
	SUBROUTINE MODULE_GET_STRING(PARS_GET, NAME, VALUE)
	IMPLICIT NONE
	CHARACTER*(*) NAME, VALUE
	CHARACTER*512 EXTRACT_STRING
	INTEGER INAME(21),IVALUE(129)
	EXTERNAL PARS_GET,REPLACE_STRING,G3_MODULE_GET_STRING,
     1		 EXTRACT_STRING
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
	CALL G3_MODULE_GET_STRING(PARS_GET, INAME, IVALUE)
	VALUE = EXTRACT_STRING(IVALUE(2), IVALUE(1))
	RETURN
	END
C
      	SUBROUTINE MODULE_GET_REAL_ARRAY(PARS_GET, NAME, VALUE, LENGTH)
	IMPLICIT NONE
	CHARACTER*(*) NAME
	INTEGER INAME(21), LENGTH
	REAL VALUE(*)
	EXTERNAL PARS_GET,REPLACE_STRING,G3_MODULE_GET_REAL_ARRAY
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
	CALL G3_MODULE_GET_REAL_ARRAY(PARS_GET, INAME, VALUE, LENGTH)
	RETURN
	END
C
      	SUBROUTINE MODULE_GET_DOUBLE_ARRAY(PARS_GET, NAME, VALUE, LENGTH)
	IMPLICIT NONE
	CHARACTER*(*) NAME
	INTEGER INAME(21), LENGTH
	DOUBLE PRECISION VALUE(*)
	EXTERNAL PARS_GET,REPLACE_STRING,G3_MODULE_GET_DOUBLE_ARRAY
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
	CALL G3_MODULE_GET_DOUBLE_ARRAY(PARS_GET, INAME, VALUE, LENGTH)
	RETURN
	END
C
      	SUBROUTINE MODULE_GET_INT_ARRAY(PARS_GET, NAME, VALUE, LENGTH)
	IMPLICIT NONE
	CHARACTER*(*) NAME
	INTEGER INAME(21), LENGTH
	INTEGER VALUE(*)
	EXTERNAL PARS_GET,REPLACE_STRING,G3_MODULE_GET_INT_ARRAY
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
	CALL G3_MODULE_GET_INT_ARRAY(PARS_GET, INAME, VALUE, LENGTH)
	RETURN
	END
C
      	SUBROUTINE MODULE_PUT_INT(PARS_PUT, NAME, VALUE)
	IMPLICIT NONE
	CHARACTER*(*) NAME
	INTEGER INAME(21)
	INTEGER VALUE
	EXTERNAL PARS_PUT,REPLACE_STRING,G3_MODULE_PUT_INT
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
	CALL G3_MODULE_PUT_INT(PARS_PUT, INAME, VALUE)
	RETURN
	END
C
      	SUBROUTINE MODULE_PUT_REAL(PARS_PUT, NAME, VALUE)
	IMPLICIT NONE
	CHARACTER*(*) NAME
	INTEGER INAME(21)
	REAL VALUE
	EXTERNAL PARS_PUT,REPLACE_STRING,G3_MODULE_PUT_REAL
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
	CALL G3_MODULE_PUT_REAL(PARS_PUT, INAME, VALUE)
	RETURN
	END
C
      	SUBROUTINE MODULE_PUT_DOUBLE(PARS_PUT, NAME, VALUE)
	IMPLICIT NONE
	CHARACTER*(*) NAME
	INTEGER INAME(21)
	DOUBLE PRECISION VALUE
	EXTERNAL PARS_PUT,REPLACE_STRING,G3_MODULE_PUT_DOUBLE
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
	CALL G3_MODULE_PUT_DOUBLE(PARS_PUT, INAME, VALUE)
	RETURN
	END
C
      	SUBROUTINE MODULE_PUT_STRING(PARS_PUT, NAME, VALUE)
	IMPLICIT NONE
	CHARACTER*(*) NAME, VALUE
	INTEGER INAME(21),IVALUE(129)
	EXTERNAL PARS_PUT,REPLACE_STRING,G3_MODULE_PUT_STRING
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
	CALL REPLACE_STRING(VALUE, LEN(VALUE), IVALUE)
	CALL G3_MODULE_PUT_STRING(PARS_PUT, INAME, IVALUE)
	RETURN
	END
C
        SUBROUTINE MODULE_PUT_STRING_ARRAY(PARS_PUT, NAME, 
     1                                     VALUE, LENGTH)
        IMPLICIT NONE
C HANDLE(2) must be big enough to take a "void*"
        INTEGER INAME(21),IVALUE(129),I,HANDLE(2),LENGTH
        CHARACTER*(*) NAME, VALUE(LENGTH)
        EXTERNAL PARS_PUT,REPLACE_STRING,G3_MODULE_STRING_ARRAY_ALLOC,
     1           G3_MODULE_STRING_ARRAY_ADD
        CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
        CALL G3_MODULE_STRING_ARRAY_ALLOC(LENGTH, HANDLE)
        DO I = 1, LENGTH
            CALL REPLACE_STRING(VALUE(I), LEN(VALUE(I)), IVALUE)
            CALL G3_MODULE_STRING_ARRAY_ADD(HANDLE, I, IVALUE)
        ENDDO
        CALL G3_MODULE_STRING_ARRAY_FREE(PARS_PUT, INAME, HANDLE)
        RETURN
        END
C
      	INTEGER FUNCTION MODULE_PUT_ND_REAL_ARRAY(PARS_PUT, NAME, VALUE, 
     1                                            DIMS_ARRAY, NDIMS)
	IMPLICIT NONE
	CHARACTER*(*) NAME
	INTEGER INAME(21), LENGTH, NDIMS, G3_MODULE_PUT_ND_REAL_ARRAY
	REAL VALUE(*)
	INTEGER DIMS_ARRAY(NDIMS), FLIPPED_DIMS_ARRAY(128), I
	EXTERNAL PARS_PUT, REPLACE_STRING, G3_MODULE_PUT_REAL_ARRAY
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
C *** We need to flip the DIMS array due to FORTRAN storing
C *** column wise and C row wise
        DO I = 1,NDIMS
            FLIPPED_DIMS_ARRAY(NDIMS-I+1) = DIMS_ARRAY(I)
        ENDDO
	MODULE_PUT_ND_REAL_ARRAY = G3_MODULE_PUT_ND_REAL_ARRAY(PARS_PUT, 
     1           INAME, VALUE, FLIPPED_DIMS_ARRAY, NDIMS)
	RETURN
	END
C
      	SUBROUTINE MODULE_PUT_REAL_ARRAY(PARS_PUT, NAME, VALUE, LENGTH)
	IMPLICIT NONE
	CHARACTER*(*) NAME
	INTEGER INAME(21), LENGTH
	REAL VALUE(*)
	EXTERNAL PARS_PUT,REPLACE_STRING,G3_MODULE_PUT_REAL_ARRAY
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
	CALL G3_MODULE_PUT_REAL_ARRAY(PARS_PUT, INAME, VALUE, LENGTH)
	RETURN
	END
C
      	SUBROUTINE MODULE_PUT_DOUBLE_ARRAY(PARS_PUT, NAME, VALUE, LENGTH)
	IMPLICIT NONE
	CHARACTER*(*) NAME
	INTEGER INAME(21), LENGTH
	DOUBLE PRECISION VALUE(*)
	EXTERNAL PARS_PUT,REPLACE_STRING,G3_MODULE_PUT_DOUBLE_ARRAY
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
	CALL G3_MODULE_PUT_DOUBLE_ARRAY(PARS_PUT, INAME, VALUE, LENGTH)
	RETURN
	END
C
      	SUBROUTINE MODULE_PUT_INT_ARRAY(PARS_PUT, NAME, VALUE, LENGTH)
	IMPLICIT NONE
	CHARACTER*(*) NAME
	INTEGER INAME(21), LENGTH
	INTEGER VALUE(*)
	EXTERNAL PARS_PUT,REPLACE_STRING,G3_MODULE_PUT_INT_ARRAY
	CALL REPLACE_STRING(NAME, LEN(NAME), INAME)
	CALL G3_MODULE_PUT_INT_ARRAY(PARS_PUT, INAME, VALUE, LENGTH)
	RETURN
	END
C
	SUBROUTINE MODULE_PRINT(S)
	IMPLICIT NONE
	INTEGER NORMAL, INFORMATION, ERROR
	PARAMETER(NORMAL=0, INFORMATION=1, ERROR=2)
	CHARACTER*(*) S
	INTEGER IS(129)
	EXTERNAL REPLACE_STRING, G3_MODULE_PRINT
	CALL REPLACE_STRING(S, LEN(S), IS)
	CALL G3_MODULE_PRINT(IS, NORMAL)
	RETURN
	END
C
	SUBROUTINE MODULE_INFORMATION(S)
	IMPLICIT NONE
	INTEGER NORMAL, INFORMATION, ERROR
	PARAMETER(NORMAL=0, INFORMATION=1, ERROR=2)
	CHARACTER*(*) S
	INTEGER IS(129)
	EXTERNAL REPLACE_STRING, G3_MODULE_PRINT
	CALL REPLACE_STRING(S, LEN(S), IS)
	CALL G3_MODULE_PRINT(IS, INFORMATION)
	RETURN
	END
C
	SUBROUTINE MODULE_ERROR(OBJECT, FAILURE, SOLUTION)
	IMPLICIT NONE
	CHARACTER*(*) OBJECT, FAILURE, SOLUTION
	EXTERNAL FERROR_ADD
	CALL FERROR_ADD(OBJECT, FAILURE, SOLUTION)
	RETURN
	END
C
C Return 0 on success, 1 on error
C
	INTEGER FUNCTION MODULE_OPEN_STDIO(INPUT, OUTPUT)
	IMPLICIT NONE
	BYTE ITTY(32)
	CHARACTER*32 TTY
	INTEGER STDIO_UNIT, STAT, TTY_LEN, INPUT, OUTPUT
	EXTERNAL G3_MODULE_OPEN_STDIO, TRUELEN
	EQUIVALENCE (TTY,ITTY)
C *** Get terminal name i.e. /dev/tty??
	MODULE_OPEN_STDIO = 0
	TTY_LEN = 32
	CALL G3_MODULE_OPEN_STDIO(ITTY, TTY_LEN)
	OPEN(UNIT=INPUT, FILE=TTY(1:TTY_LEN), STATUS='OLD', IOSTAT=STAT)
	IF (STAT .NE. 0) THEN
	    WRITE(6,*) 'MODULE_OPEN_STDIO: Error opening '//TTY(1:TTY_LEN)//' as unit ', INPUT
	    MODULE_OPEN_STDIO = 1
 	ENDIF
	OPEN(UNIT=OUTPUT, FILE=TTY(1:TTY_LEN), STATUS='OLD', IOSTAT=STAT)
	IF (STAT .NE. 0) THEN
	    WRITE(6,*) 'MODULE_OPEN_STDIO: Error opening '//TTY(1:TTY_LEN)//' as unit ', OUTPUT
	    MODULE_OPEN_STDIO = 1
 	ENDIF
	RETURN
	END
C
C Return 0 on success, 1 on error
C
	INTEGER FUNCTION MODULE_CLOSE_STDIO(INPUT, OUTPUT)
	IMPLICIT NONE
	INTEGER STDIO_UNIT, STAT, INPUT, OUTPUT
	MODULE_CLOSE_STDIO = 0
	CLOSE(UNIT=INPUT, IOSTAT=STAT)
	IF (STAT .NE. 0) THEN
            WRITE(6,*) 'MODULE_CLOSE_STDIO: Error closing unit ', INPUT
	    MODULE_CLOSE_STDIO = 1
        ENDIF
	CLOSE(UNIT=OUTPUT, IOSTAT=STAT)
	IF (STAT .NE. 0) THEN
            WRITE(6,*) 'MODULE_CLOSE_STDIO: Error closing unit ', OUTPUT
	    MODULE_CLOSE_STDIO = 1
        ENDIF
	RETURN
	END
C
	SUBROUTINE F_MAP_FORTRAN_STDIO(TTY, TTY_LEN)
	IMPLICIT NONE
	INTEGER TTY_LEN, I, STAT
	BYTE TTY(TTY_LEN)
	CHARACTER*64 TTY_NAME
	EXTERNAL F_UNMAP_FORTRAN_STDIO
	DO I=1,MIN(TTY_LEN,64)
	    TTY_NAME(I:I)=CHAR(TTY(I))
	ENDDO
	CALL F_UNMAP_FORTRAN_STDIO
	OPEN(UNIT=5, IOSTAT=STAT, FILE=TTY_NAME(1:TTY_LEN), STATUS='OLD')
	IF (STAT .NE. 0) THEN
	    WRITE(6,*) 'F_MAP_FORTRAN_STDIO: Error reassigning unit 5 to '//TTY_NAME(1:TTY_LEN)
	ENDIF
	OPEN(UNIT=6, IOSTAT=STAT, FILE=TTY_NAME(1:TTY_LEN), STATUS='OLD')
	IF (STAT .NE. 0) THEN
	    WRITE(6,*) 'F_MAP_FORTRAN_STDIO: Error reassigning unit 6 to '//TTY_NAME(1:TTY_LEN)
	ENDIF
	RETURN
	END
C
	SUBROUTINE F_UNMAP_FORTRAN_STDIO
	IMPLICIT NONE
	LOGICAL FLAG
	INTEGER STAT
	INQUIRE(UNIT=5, OPENED=FLAG, IOSTAT=STAT)
	IF (FLAG .AND. (STAT .EQ. 0)) THEN
	    CLOSE(5,IOSTAT=STAT)
	ENDIF
	INQUIRE(UNIT=6, OPENED=FLAG, IOSTAT=STAT)
	IF (FLAG .AND. (STAT .EQ. 0)) THEN
	    CLOSE(6,IOSTAT=STAT)
	ENDIF
	RETURN
	END
C
C *** Current interface version
C
	INTEGER FUNCTION MODULE_GET_VERSION(MAJOR, MINOR)
	IMPLICIT NONE
	INTEGER MAJOR, MINOR, G3_MODULE_GET_VERSION
	EXTERNAL G3_MODULE_GET_VERSION
	MODULE_GET_VERSION = G3_MODULE_GET_VERSION(MAJOR, MINOR)
	RETURN 
	END
C
C *** Check MAJOR & MINOR are compatable with current interface
C
	INTEGER FUNCTION MODULE_VERSION_OK(MAJOR, MINOR)
        IMPLICIT NONE
        INTEGER MAJOR, MINOR, G3_MODULE_VERSION_OK
	EXTERNAL G3_MODULE_VERSION_OK
 	MODULE_VERSION_OK = G3_MODULE_VERSION_OK(MAJOR, MINOR)
   	RETURN
	END
C
