/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"

static const char* rcsid = "@(#)$Id: motifutils.c,v 1.4 1996/03/10 18:09:53 faa Exp $";
USE_RCSID(rcsid);

#ifdef HAVE_LIBXM

#include <string.h>
#include <stdio.h>
#include <Xm/Xm.h>
#include "motifdriver_functions.h"
#include "motifdriver.h"
static char stra[512];


/* Currently not used
void reparent(	Widget parent,
		int xpos,
		int ypos,
		int width,
		int height) {

	ParentWindow = parent;
	childwindow = 1;

	userpos.valid = 1;
	userpos.xpix = xpos;
	userpos.ypix = ypos;

	usersize.valid = 1;
	usersize.widthpix = width;
	usersize.heightpix = height;

	return;
}
*/

void startsize (int width, int height) {

	usersize.valid = 1;
	usersize.widthpix = width;
	usersize.heightpix = height;

	return;
}

void startsizeins (float width, float height) {

	usersize.valid = 2;

	usersize.widthmm = width;
	usersize.heightmm = height;
	return;
}

void nomenus () {

	userinfo.valid = 1;
	userinfo.nomenus = True;

	return;
}

void startposition (int xpos, int ypos) {

	userpos.valid = 1;
	userpos.xpix = xpos;
	userpos.ypix = ypos;

	return;
}

void starttitle(char *str1, char *str2) {

	userinfo.valid = 1;
	userinfo.titlelen = strlen(str1);
	strcpy(userinfo.title,str1);
	strcpy(userinfo.iconname,str2);

	return;}

void settitle(char *str1) {

	if (childwindow != 0) return;

	XtVaSetValues(TopWindow,XmNtitle, str1, NULL);
	return;
}

void seticonname(char *str1) {

	if (childwindow != 0) return;

	XtVaSetValues(TopWindow,XmNiconName, str1, NULL);
	return;
}

void setredrawfunct(funcPtr func) {

    savedfunct = func;
    return;
}

void setexitfunct(funcPtrI func) {

    exitfunct = func;
    return;
}

void destroyapplication() {
    XtDestroyApplicationContext(ApplicationContext);
}

void startusermenu(char *str1,int n, char *strp,funcPtrI func) {
    int f;
    int counter = n;
    int length = strlen(strp);

    sprintf(stra,"%s",strp);

    sprintf(usermenu.title,"%s\n", str1);

    if (n > 20) n = 20;
    usermenu.nitems = n;

    usermenu.items[0] = stra;

    for (f=length; f>=0; f--) {
	if (stra[f] == ',') {
		stra[f] = 0;
		usermenu.items[--counter] = &stra[f+1];
	}
    }

    menufunct = func;
    return;
}

#endif /* HAVE_LIBXM */
