/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include "g_types.h"
#include "Pginclude.h"
#include "n_d_plot.h"

static const char* rcsid = "@(#)$Id: n_d_plot.cxx,v 1.3 1997/05/06 09:57:11 cmm Exp $";
USE_RCSID(rcsid);

int NDimensionalPlot::setup(g_real* values, int* dims_array, int ndims, CoordinateTransformFunction* func)
{
    m_func = func;
    m_values.setup(values, dims_array, ndims);
    return 0;
}

NDimensionalPlot::NDimensionalPlot(g_real* values, int* dims_array, int ndims, CoordinateTransformFunction* func) : 
		Drawable_objects()
{
    setup(values, dims_array, ndims, func);
}

NDimensionalPlot::~NDimensionalPlot()
{
    delete m_func;
}

void NDimensionalPlot::display()
{
}
