/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef N_DIMENSIONAL_PLOT_H
#define N_DIMENSIONAL_PLOT_H

#include "Drawable_objects.h"
#include "drawable_values.h"
#include "coord_trans_func.h"

class NDimensionalPlot : public Drawable_objects
{
    protected:
    	DrawableValues m_values;
	CoordinateTransformFunction* m_func;
    	
    public:
    	NDimensionalPlot(g_real* values, int* dims_array, int ndims, CoordinateTransformFunction* func = 0);
	NDimensionalPlot(CoordinateTransformFunction* func = 0) : Drawable_objects(), m_func(func) {}
    	int setup(g_real* values, int* dims_array, int ndims, CoordinateTransformFunction* func = 0);
	void display();
	int forwardFunction(int* flags, const g_real* val_in, g_real* val_out) 
				{ return m_func->forwardFunction(flags, val_in, val_out); }
	int reverseFunction(int* flags, const g_real* val_in, g_real* val_out) 
				{ return m_func->reverseFunction(flags, val_in, val_out); }
  	CoordinateTransformFunction* function() { return m_func; }
	const DrawableValues& values() const { return m_values; }
	~NDimensionalPlot();
};

#endif /* N_DIMENSIONAL_PLOT_H */
