/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include "Pginclude.h"
#include "Genie_functions.h"

/*
 * Set the tag to assign to newly displayed objects - uses function 23 in PGPLOT dirver
 * Currently used to set tag on Tk canvas widget
 */
int set_current_object_tag(const char* tag)
{
    String dev = current_device_type();
    if (dev != "TK")
	return 0;
// set tag for Tk canvas - if change from "pg + pointer" must edit tkdriv.c
    if (tag == 0)
    {
	GRESC(String(" "));	/* reset tag - FORTRAN doesn't like 0 length strings */
    }
    else
    {
	GRESC(String(tag));
    }
    return 0;
}
