/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include "Pginclude.h"
#include "g_types.h"
//
// set up defaults
//
// ---
// *** include Picture externals
//
#include "Pictlist.h"

// ---
// *** include all object headers
//
#include "Text.h"
#include "Axes.h"
#include "Plot.h"
#include "Polyline.h"
#include "Marker.h"
#include "H_err_bars.h"
#include "V_err_bars.h"
#include "Histogram.h"
#include "Multiplot.h"
#include "Errors.h"
#include "contour_plot.h"

static const char* rcsid = "@(#)$Id: objinit.cxx,v 1.9 1997/04/18 09:08:45 cmm Exp $";
USE_RCSID(rcsid);

#ifndef NOglob
int Current_Picture = -1;
Picture *PicturePTR[GENIE_MAXPICT]; 

int	Drawable_objects::LINE_THICKNESS = 2;
int	Drawable_objects::LINE_COLOUR = 1;

String	Text::STRING_TEXT = " ";
float	Text::ORIENTATION = 0.0F;
int	Text::FONT = 1;
float	Text::CHARACTER_SIZE = 1.5F;

int	Axes::BOX_VISIBLE = 1;
int	Axes::Y_AT_X0 = 0;
int	Axes::X_AT_Y0 = 0;
int	Axes::MAJOR_TICK_MARKS = 1;
int	Axes::MINOR_TICK_MARKS = 1;
int	Axes::INSET_TICKS = 1;
int	Axes::XLINEAR = 1;
int	Axes::YLINEAR = 1;
float	Axes::CHARACTER_SIZE = 1.5F;
int	Axes::FONT = 1;
float	Axes::TEXT_CHAR_SIZE = 1.5F;
String  Axes::X_LABEL = " ";
String  Axes::Y_LABEL = " ";
int	Axes::Y_ORIENTATION = 0;
int	Axes::GRATICULE = 0;
String  Axes::TITLE = " ";
int	Axes::LINE_TYPE = 1;

int	Polyline::LINE_TYPE = 1;

int	Marker::SYMBOL = 2;
float	Marker::CHARACTER_SIZE = 0.5F;

float	H_err_bars::END_SIZE = 0.0F;

float	V_err_bars::END_SIZE = 0.0F;

int	Histogram::BIN_CENTRE = 0;
int	Histogram::LINE_TYPE = 1;

int	Multiplot::SLANT = 0;
int	Multiplot::BIN_CENTRE = 0;
int	Multiplot::LINE_TYPE = 1;

String	Errors::OBJECT[5] = { "", "", "", "", "" };
String	Errors::SOLUTION[5] = { "", "", "", "", "" };
String	Errors::FAILURE[5] = { "", "", "", "", "" };

int ContourPlot::LINE_STYLE = 0;

#endif

void init_defaults() {

	// *** initialise the picture storage
	for(int i=0; i<GENIE_MAXPICT; i++)
	{
	    PicturePTR[i] = 0;
	}
}
