/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
// -----------------------------------------------------------------------------
// PICTURE_DISPLAY.C
//
// Description: C++ code to allow creation of a Genie object-graphics Picture
//		display...
//
//
// *** local include only
#include "Pictlist.h"
#include "Genie_functions.h"
#include "Viewport.h"
#include "Text.h"
#include "Pginclude.h"

static const char* rcsid = "@(#)$Id: picture_display.cxx,v 1.8 1997/06/25 20:41:36 faa Exp $";
USE_RCSID(rcsid);

#ifndef NOwait
void wait() {
    int f;
    for (f=0; f<6000; f++) {
    // do nothing
	}
	}
#endif
void picture_display(float world[2]) {
// DO I NEED TO PASS ID THROU' ?????

	char ch[2];
	String ch1;
	static const char password[] = "GENIE";
	float x[2];
	float device[2];
	int f;

	for (f=0; f<5; f++) {
		get_window_cursor(world,device,ch);
		if (ch[0] != password[f]) return;
	};

	x[0] = 0.0F;
	x[1] = 0.0F;

	// *** construct a new picture
	Viewport view1(0.1F,0.9F,0.1F,0.9F,0.0F,40.0F,0.0F,30.0F);
	Text t1(6.0F,21.0F,"Genie",12.0F,6,0.0F,1,6);
	Text t2(0.0F,30.0F,"I dream of ...",1.0F,5,0.0F,2,1);
	Text t3(30.0F,18.0F,"... with the light brown hair.",1.0F,5,0.0F,2,1);
	Text t4(8.0F,14.0F,"Genie was released from its bottle by:",1.3F,3,0.0F,2,1);
	Text t5(11.0F,12.0F,"Chris Moreton-Smith,",1.8F,3,0.0F,3,1);
	Text t7(14.0F,10.0F,"Steve Johnston",1.8F,3,0.0F,3,1);
	Text t10(13.3F,6.0F,"Freddie Akeroyd",1.8F,3,0.0F,3,1);
	Text t6(20.0F,8.0F,"&",1.8F,3,0.0F,3,1);
	Text t8(-2.0F,1.0F,"from the original by: W I F David, M W Johnson, K J Knowles, C M Moreton-Smith",1.3F,5,0.0F,4,1);
	Text t9(4.0F,-1.0F,"G D Crosbie, E P Campbell, S P Graham and J S Lyall.",1.3F,5,0.0F,4,1);

	// *** clear existing picture
	clear_device();

	// *** display the new picture
        view1.display();

	Text t20(6.0F,21.0F,"Genie",12.0F,1,0.0F,1,6);
	Text t21(6.0F,21.0F,"Genie",12.0F,2,0.0F,1,6);
	Text t22(6.0F,21.0F,"Genie",12.0F,3,0.0F,1,6);
	Text t23(6.0F,21.0F,"Genie",12.0F,4,0.0F,1,6);
	Text t24(6.0F,21.0F,"Genie",12.0F,5,0.0F,1,6);
	Text t25(6.0F,21.0F,"Genie",12.0F,6,0.0F,1,6);
	Text t26(6.0F,21.0F,"Genie",12.0F,7,0.0F,1,6);
	Text t27(6.0F,21.0F,"Genie",12.0F,8,0.0F,1,6);
	Text t28(6.0F,21.0F,"Genie",12.0F,9,0.0F,1,6);
	Text t29(6.0F,21.0F,"Genie",12.0F,10,0.0F,1,6);
	Text t30(6.0F,21.0F,"Genie",12.0F,11,0.0F,1,6);

	t2.display();
        t1.display();
	t3.display();
        t4.display();
	t5.display();
	t7.display();
        t6.display();
	t10.display();
        t8.display();
        t9.display();

	for (f=0; f<10; f++) {
	pgupdt();
	wait();
	t20.display();
	pgupdt();
	wait();
	t21.display();
	pgupdt();
	wait();
	t22.display();
	pgupdt();
	wait();
	t23.display();
	pgupdt();
	wait();
	t24.display();
	pgupdt();
	wait();
	t25.display();
	pgupdt();
	wait();
	t26.display();
	pgupdt();
	wait();
	t27.display();
	pgupdt();
	wait();
	t28.display();
	pgupdt();
	wait();
	t29.display();
	pgupdt();
	wait();
	t30.display();
	};

	// *** get a cursor
	view1.cursor(x,device,ch1);


	// *** restore old picture
	clear_device();
	redraw_picture(0,0);
	
}
	
