/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef READ_ASCII_H
#define READ_ASCII_H

class SmalltalkObject;

int read_ascii(const char* file, const String& field_names, GenieWorkspace& result, char comment = '#', char delim = '\n');
int read_ascii_stream(fstream& fs, GenieVariable& result);
int lines_in_file(fstream& ifs, char comment = '#', char delim = '\n');
int lines_in_file(const char* file, char comment = '#', char delim = '\n');
int skip_comments(fstream& input_stream, char comment = '#', char delim = '\n');
int write_ascii(const char* file, const GenieString& comment, const GenieString& format, SmalltalkObject& gv);

#endif /* READ_ASCII_H */
