C   Open GENIE, a program for neutron scattering data analysis & display
C   ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
C   Copyright (C) 1996,1997
C
C   This program is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C
C
C To read a G2 intermediate file ... hacked from G2 code
C
C
C IMODE:	0 = normal
C		1 = just get nspec
C
C
C
C *** error codes
C
C 0 = OK
C 1 = File does not exist
C 2 = error in opening file
C 4 = error in getsect
C 6 = address of X-values section or Detector section, Code needs updating to cope with this file
C 8 = Code needs updating to cope with this file
C 10 = illegal block number
C 12 = file not open
C 14 = Error in VAXF_TO_LOCAL
C
	SUBROUTINE READ_INT(IUNIT,FILENAME,LENNAME,IBLOCK,XARRAY,
     1                      YARRAY,EARRAY,NO_OF_SPECTRA,NO_SPECTRUM,
     2			    NPT,DELTA,RUN_NUMBER,XCODE,
     3                      YCODE,E_MODE,FI,L1,L2,E_FIXED,TTHET,
     4			    RUN_DURATION,INST_NAME,LONG_TITLE,
     5			    RUN_USER,START_TIME,WS_HISTORY,
     6			    XCAPTION,YCAPTION,IMODE,USER_PAR,IERROR)
	IMPLICIT NONE
C
C    FILENAME is the filename 
C    LENNAME is the length of the filename
C    IERROR  is the status return
C    IBLOCK is the block number to be read from the file
C    IUNIT
C
	INTEGER LENNAME,IERROR,IBLOCK
C  Work space
	INTEGER*4 LEN_STREAMS, CH_OF_YMIN
	INTEGER*4 CH_OF_YMAX, L_DAT_FILE, NPT, IMODE
	INTEGER*4 IWORK(256), INST_STR, LEN_PDFN, NO_SPECTRUM
	REAL*4 RWORK(256), FI, XMN, XMX, YMN, YMX, PI
	CHARACTER*1024 CWORK
	CHARACTER*75 DAT_FILE
	REAL*4 USER_PAR(30),L1,L2
C
	LOGICAL EOD,FOUND,OPENFILE,SUCCESS
	CHARACTER*80 FILENAME,NAMEFILE
	INTEGER NO_OF_SPECTRA,IUNIT,I,J,K,KK,ISTATUS,II,IOERR
	INTEGER LEN_PBLOCKS,LEN_XBLOCKS,LEN_YBLOCKS,LEN_EBLOCKS
	INTEGER ADD_SPECTRA
	INTEGER*4 XCODE, YCODE, E_MODE, RUN_NUMBER, INST_CODE
	CHARACTER*200 WS_HISTORY
	CHARACTER*80 LONG_TITLE
	CHARACTER*8 INST_NAME
	CHARACTER*40 XCAPTION, YCAPTION, MCAPTION
	CHARACTER*20 RUN_USER, START_TIME                   
	REAL*4 DELTA, RUN_DURATION, TTHET, E_FIXED, XARRAY(*), 
     1      YARRAY(*), EARRAY(*)
	INTEGER*4 NO_SPCTRUM
	COMMON /INTERM_SAVE/ NAMEFILE, OPENFILE
	SAVE /INTERM_SAVE/
	EQUIVALENCE (IWORK,CWORK), (IWORK,RWORK)
	EXTERNAL GETSECT, FERROR_ADD,FASTGET_INIT
	EXTERNAL VAXF_TO_LOCAL, VAX_TO_LOCAL_INT, VAX_TO_LOCAL_INTS
	INTEGER VAX_TO_LOCAL_INT,FASTGET_INIT
	DATA OPENFILE/.FALSE./
	PI=ACOS(-1.0)
	IERROR = 0
	    INQUIRE(FILE=FILENAME(1:LENNAME),EXIST=FOUND)
	    IF (.NOT.FOUND) THEN
		IERROR=1
		RETURN
	    ENDIF
CC	OPEN(UNIT=IUNIT,FILE=FILENAME(1:LENNAME),FORM='UNFORMATTED',
CC     1       RECL=128,ACCESS='DIRECT',STATUS='OLD',READONLY,
CC     2       SHARED,IOSTAT=IOERR)
C	OPEN(UNIT=IUNIT,FILE=FILENAME(1:LENNAME),FORM='UNFORMATTED',
C     1       RECL=128,ACCESS='DIRECT',STATUS='OLD', IOSTAT=IOERR)
C	IF (IOERR .NE. 0) THEN
C	    IERROR=2
C	    RETURN
C	ENDIF
	CWORK = FILENAME(1:LENNAME)
	I = FASTGET_INIT(IWORK, IUNIT)
	    NAMEFILE=FILENAME
C  read in FORMAT section
	    CALL GETSECT(1,91,IWORK,IUNIT,IOERR)
	    IF (IOERR .NE. 0) THEN
		CALL FERROR_ADD('READ_INT','in GETSECT', ' ')
C		CLOSE(IUNIT)
		IERROR=4
	        RETURN
	    ENDIF
	    CALL VAX_TO_LOCAL_INTS(IWORK(21), 21)
	    IF (IWORK(23).ne.0.or.IWORK(24).ne.0) then
C		CLOSE(IUNIT)
		IERROR=6
	        RETURN
	    ENDIF
	    add_spectra=IWORK(25)	!address of Spectra section
	    no_of_spectra=IWORK(26)	!no. of spectra
	    len_pblocks=IWORK(27)	!length of P block(GENIE_HDR1+HDR2)
	    len_xblocks=IWORK(28)	!length of x block
	    len_yblocks=IWORK(29)	!length of y block
	    len_eblocks=IWORK(30)	!length of e block
	    if (imode .eq. 1) then
C *** just return number of points ***
	        npt=len_xblocks
C	 	CLOSE(IUNIT)
		return
	    endif
	    I=IWORK(31)+		!length of u1 block
     +		IWORK(32)+		!length of u2 block
     +		IWORK(33)+		!length of u3 block
     +		IWORK(34)+		!length of u4 block
     +		IWORK(35)+		!length of u5 block
     +		IWORK(36)+		!length of u6 block
     +		IWORK(37)+		!length of u7 block
     +		IWORK(38)+		!length of u8 block
     +		IWORK(39)+		!length of u9 block
     +		IWORK(40)+		!length of u10 block
     +		IWORK(41)		!length of u11 block
C  length of U block(s) not zero. Code not written for this yet
	    IF (I.ne.0) then
		IERROR=8
		OPENFILE=.FALSE.
C	 	CLOSE(IUNIT)
		RETURN
	    ENDIF
	    OPENFILE=.TRUE.
	    IF(.NOT.OPENFILE) THEN
		IERROR=12
		RETURN
	    ENDIF
C  make this the current stream
C
	    IF (IBLOCK.EQ.0) IBLOCK=1
	    IF (IBLOCK.LE.0.OR.IBLOCK.GT.NO_OF_SPECTRA) THEN
		IERROR=10
C	 	CLOSE(IUNIT)
		RETURN
	    ENDIF
C  calc start address of block
	    II=ADD_SPECTRA+(LEN_PBLOCKS+LEN_XBLOCKS+LEN_YBLOCKS+
     +			LEN_EBLOCKS)*(IBLOCK-1)
C Read in info for header 2 common block
	    CALL GETSECT(II,30,USER_PAR(1),IUNIT,IOERR)
	    IF (IOERR .NE. 0) THEN
		CALL FERROR_ADD('READ_INT','in GETSECT', ' ')
C		CLOSE(IUNIT)
		IERROR=4
	        RETURN
	    ENDIF
	    CALL VAXF_TO_LOCAL(USER_PAR(1),30,KK)
	    IF (KK .NE. 0) THEN
		IERROR = 14
C	 	CLOSE(IUNIT)
		RETURN
	    ENDIF
C Read in info for header 1 common block
	    CALL GETSECT(II+30,155,IWORK,IUNIT,IOERR)
	    IF (IOERR .NE. 0) THEN
		CALL FERROR_ADD('READ_INT','in GETSECT', ' ')
C		CLOSE(IUNIT)
		IERROR=4
	        RETURN
	    ENDIF
	    ch_of_ymin=VAX_TO_LOCAL_INT(IWORK(1))
	    ch_of_ymax=VAX_TO_LOCAL_INT(IWORK(2))
	    CALL VAXF_TO_LOCAL(RWORK(3),1,KK)
	    IF (KK .NE. 0) THEN
		IERROR = 14
C	 	CLOSE(IUNIT)
		RETURN
	    ENDIF
	    delta=RWORK(3)
	    l_dat_file=VAX_TO_LOCAL_INT(IWORK(4))
	    dat_file=CWORK(17:96)
	    CALL VAXF_TO_LOCAL(RWORK(25),1,KK)
	    IF (KK .NE. 0) THEN
		IERROR = 14
C	 	CLOSE(IUNIT)
		RETURN
	    ENDIF
	    fi=RWORK(25)
	    inst_code=VAX_TO_LOCAL_INT(IWORK(26))
	    inst_name=CWORK(105:112)
	    inst_str=VAX_TO_LOCAL_INT(IWORK(29))
	    xcode=VAX_TO_LOCAL_INT(IWORK(30))
	    len_pdfn=VAX_TO_LOCAL_INT(IWORK(31))
	    CALL VAXF_TO_LOCAL(RWORK(32),2,KK)
	    IF (KK .NE. 0) THEN
		IERROR = 14
C	 	CLOSE(IUNIT)
		RETURN
	    ENDIF
	    L1=RWORK(32)
	    L2=RWORK(33)
	    long_title=CWORK(133:212)
	    no_spectrum=VAX_TO_LOCAL_INT(IWORK(54))
	    npt=VAX_TO_LOCAL_INT(IWORK(55))
	    if (npt .gt. len_xblocks) then
		CALL FERROR_ADD('READ_INT','npt > len_xblocks', ' ')
C		CLOSE(IUNIT)
		IERROR=4
	        RETURN
	    endif
	    run_number=VAX_TO_LOCAL_INT(IWORK(56))
	    run_user=CWORK(225:244)
	    CALL VAXF_TO_LOCAL(RWORK(62),1,KK)
	    IF (KK .NE. 0) THEN
		IERROR = 14
C	 	CLOSE(IUNIT)
		RETURN
	    ENDIF
	    run_duration=RWORK(62)
	    start_time=CWORK(249:268)
	    CALL VAXF_TO_LOCAL(RWORK(68),1,KK)
	    IF (KK .NE. 0) THEN
		IERROR = 14
C	 	CLOSE(IUNIT)
		RETURN
	    ENDIF
C *** stored in radians for G2, degrees in G3 ***
	    tthet=RWORK(68)*180.0/PI
	    ws_history=CWORK(273:472)
	    CALL VAXF_TO_LOCAL(RWORK(119),4,KK)
	    IF (KK .NE. 0) THEN
		IERROR = 14
C	 	CLOSE(IUNIT)
		RETURN
	    ENDIF
	    xmn=RWORK(119)
	    xmx=RWORK(120)
	    ymn=RWORK(121)
	    ymx=RWORK(122)
	    xcaption=CWORK(489:528)
	    ycaption=CWORK(529:568)
	    mcaption=CWORK(569:608)
	    ycode=VAX_TO_LOCAL_INT(IWORK(153))
	    e_mode=VAX_TO_LOCAL_INT(IWORK(154))
	    CALL VAXF_TO_LOCAL(RWORK(155),1,KK)
	    IF (KK .NE. 0) THEN
		IERROR = 14
C	 	CLOSE(IUNIT)
		RETURN
	    ENDIF
	    e_fixed=RWORK(155)
C Read x array  (1 extra value as these are boundaries not bins)
	    CALL GETSECT(II+LEN_PBLOCKS,NPT+1,XARRAY,IUNIT,IOERR)
	    IF (IOERR .NE. 0) THEN
		CALL FERROR_ADD('READ_INT','in GETSECT', ' ')
C		CLOSE(IUNIT)
		IERROR=4
	        RETURN
	    ENDIF
	    CALL VAXF_TO_LOCAL(XARRAY,NPT+1,KK)
	    IF (KK .NE. 0) THEN
C	 	CLOSE(IUNIT)
		IERROR = 14
		RETURN
	    ENDIF
C Read y array
	    CALL GETSECT(II+LEN_PBLOCKS+LEN_XBLOCKS,
     +			 NPT,YARRAY,IUNIT,IOERR)
	    IF (IOERR .NE. 0) THEN
		CALL FERROR_ADD('READ_INT','in GETSECT', ' ')
C		CLOSE(IUNIT)
		IERROR=4
	        RETURN
	    ENDIF
	    CALL VAXF_TO_LOCAL(YARRAY,NPT,KK)
	    IF (KK .NE. 0) THEN
C	 	CLOSE(IUNIT)
		IERROR = 14
		RETURN
	    ENDIF
C Read e array
	    CALL GETSECT(
     +		II+LEN_PBLOCKS+LEN_XBLOCKS+LEN_YBLOCKS,
     +				NPT,EARRAY,IUNIT,IOERR)
	    IF (IOERR .NE. 0) THEN
		CALL FERROR_ADD('READ_INT','in GETSECT', ' ')
C		CLOSE(IUNIT)
		IERROR=4
	        RETURN
	    ENDIF
	    CALL VAXF_TO_LOCAL(EARRAY,NPT,KK)
	    IF (KK .NE. 0) THEN
C	 	CLOSE(IUNIT)
		IERROR = 14
		RETURN
	    ENDIF
C
 	RETURN
	END
