/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*
 *  strcasecmp() and strcncasecmp() for machines that don't have them
 */

#include <ctype.h>
#include "strcasecmp.h"

#if 0
int strcasecmp(const char* s1, const char* s2)
{
    while(tolower(*s1) == tolower(*s2))
    {
	if (*s1 == '\0')
	    return 0;
	s1++;
	s2++;
    }
    return tolower(*s1) - tolower(*s2);
}
#endif /* 0 */
	
int strncasecmp(const char* s1, const char* s2, int n)
{
    if (n != 0)
    {
	do {
	    if (tolower(*s1) != tolower(*s2))
	    {
		return tolower(*s1) - tolower(*s2);
	    }
	    if (*s1 == '\0')
		break;
	    s1++;
	    s2++;
	} while(--n != 0);
    }
    return 0;
}
