C   Open GENIE, a program for neutron scattering data analysis & display
C   ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
C   Copyright (C) 1996,1997
C
C   This program is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C
	subroutine tran_out(lptout,mn,xout,yout,eout,
     +			xcaptout,ycaptout,out_title,
     +			delta_out,inst_code_out,inst_name_out,
     +			xcode_out,ycode_out,L1_out,L2_out,tthet_out,
     +			no_spectrum_out,run_number_out,run_user_out,
     +			run_duration_out,start_time_out,fi_out,
     +			user_par_out,st_var_out,out_history,ierror)
C
C *** ierror = 0 on success
C              1 on open error
C              2 on write error
C              3 on close error
C
C	implicit none
	integer			mn
	real 			xout(mn),yout(mn),eout(mn),user_par_out(30),st_var_out(20)
	real			L1_out,L2_out
	integer			xcode_out, ierror
	character*200		out_history
	character*80		out_title
	character*40		xcaptout,ycaptout
	character*20		start_time_out
	character*20		run_user_out
	character*8		inst_name_out

	ierror = 0
c.. Write the various parameters to temporary stream 48
	open(unit=47, status='unknown', form='unformatted', err=10)
	write(unit=47, err=20) lptout,(xout(i),i=1,lptout+1),
     +	   (yout(i),i=1,lptout),
     +	   (eout(i),i=1,lptout),xcaptout,ycaptout,out_title,
     +	   L1_out,L2_out,tthet_out,fi_out,
     +	   delta_out,inst_code_out,inst_name_out,
     +	   no_spectrum_out,run_number_out,run_user_out,
     +	   run_duration_out,start_time_out,xcode_out,ycode_out,
     +     (user_par_out(i),i=1,30),(st_var_out(i),i=1,20),out_history
	endfile(unit=47, err=20)
	close(unit=47, err=30)
c
	return
 10 	ierror = 1
	call ferror_add('TRAN_OUT','Unable to open intermediate file',
     1	                'Seek help ... this is serious')
	return
 20	ierror = 2
	call ferror_add('TRAN_OUT','Unable to write intermediate file',
     1       'Check you are not over quota or in a directory '//
     2       'where you cannot create files')
	close(unit=47, status='delete')
	return
 30 	ierror = 3
	call ferror_add('TRAN_OUT','Unable to close intermediate file',
     1	                'Seek help ... this is serious')
	return   
	end
C ----------------------------------------------------------------------- C
	subroutine tran_in(lptin,mn,xin,yin,ein,
     +			xcaptin,ycaptin,in_title,
     +			delta_in,inst_code_in,inst_name_in,
     +			xcode_in,ycode_in,L1_in,L2_in,tthet_in,
     +			no_spectrum_in,run_number_in,run_user_in,
     +			run_duration_in,start_time_in,fi_in,
     +			user_par_in,st_var_in,in_history,ierror)
C	implicit none
C
C *** ierror = 0 on success
C              1 on open error
C              2 on read error
C              3 on close error
C
	integer			mn, ierror
	real 			xin(mn),yin(mn),ein(mn),user_par_in(30),st_var_in(20)
	real			L1_in,L2_in
	integer			xcode_in
	character*200		in_history
	character*80		in_title
	character*40		xcaptin,ycaptin
	character*20		start_time_in
	character*20		run_user_in
	character*8		inst_name_in

	ierror = 0
	open(unit=48, status='unknown', form='unformatted', err=10)
	rewind(unit=48, err=10)
	read(unit=48, err=20) lptin,(xin(i),i=1,lptin+1),(yin(i),i=1,lptin),
     +	   (ein(i),i=1,lptin),xcaptin,ycaptin,in_title,
     +	   L1_in,L2_in,tthet_in,fi_in,
     +	   delta_in,inst_code_in,inst_name_in,
     +	   no_spectrum_in,run_number_in,run_user_in,
     +	   run_duration_in,start_time_in,xcode_in,ycode_in,
     +     (user_par_in(i),i=1,30),(st_var_in(i),i=1,20),in_history
	close(unit=48, status='delete', err=30)
c
	return
 10	ierror = 1
	call ferror_add('TRAN_IN','Unable to open intermediate file',
     1	                'Seek help ... this is serious')
	return
 20	ierror = 2
	call ferror_add('TRAN_IN','Intermediate file corrupted',
     1       'Check you are not over quota or in a directory '//
     2	     'where you cannot create files')
	close(unit=48, status='delete')
	return
 30	ierror = 3
	call ferror_add('TRAN_IN','Unable to close intermediate file',
     1	                'Seek help ... this is serious')
	return
	end
C
C --------------------------------------------------------------C
C
C *** hacked from Genie v2 function_command.for
C
	subroutine func_out(lpt,x,y,e,
     +		xcaption,ycaption,long_title,
     +		L1,L2,tthet,fi,delta,
     +	       	user_par,st_var,
     +		xcode,ycode,ws_history,ierror)
	implicit none
C
C *** ierror = 0 on success
C              1 on open error
C              2 on write error
C              3 on close error
C
	real			L1,L2,delta,tthet,run_duration,fi
	integer			run_number,xcode,ycode,lpt
	integer 		ierror, i, inst_code, no_spectrum
  	real 			user_par(30), st_var(20)
	character*200		ws_history
	character*80		long_title
	character*40		infile,xcaption,ycaption
	character*20		run_user,start_time
	character*8		inst_name
	real 			x(lpt+1), y(lpt), e(lpt)
	external ferror_add

	open(unit=47,status='new',form='unformatted',err=900)
	write(47,err=910) lpt,(x(i),i=1,lpt+1),(y(i),i=1,lpt),
     +		(e(i),i=1,lpt),
     +		xcaption,ycaption,long_title,
     +		L1,L2,tthet,fi,delta,
     +		(user_par(i),i=1,30),(st_var(i),i=1,20),
     +		xcode,ycode,ws_history
	close(unit=47,err=920)
	ierror = 0
	return
 900    call ferror_add('FUNC_OUT', 'unable to open file',
     1			' ')
	ierror = 1
	return
 910    call ferror_add('FUNC_OUT', 'unable to write file',
     1			'possibly over quota or in wrong directory')
	ierror = 2
	return
 920    call ferror_add('FUNC_OUT', 'unable to close file',
     1			' ')
	ierror = 3
	return
	end
C --------------------------------------------------------------C
	subroutine func_in(lpt,y,e,
     +		xcaption,ycaption,long_title,
     +		xcode,ycode,
     +		user_par,st_var,
     +		ws_history,ierror)
C
C *** lpt must be supplied in arguments ***
C
	implicit none
C
C *** ierror = 0 on success
C              1 on open error
C              2 on write error
C              3 on close error
C
	integer mn
	parameter(mn=33000)
	real			L1,L2,delta,tthet,run_duration,fi
	integer			run_number,xcode,ycode,lpt
	integer 		ierror, i, inst_code, no_spectrum
  	real 			user_par(30), st_var(20)
	character*200		ws_history
	character*80		long_title
	character*40		infile,xcaption,ycaption
	character*20		run_user,start_time
	character*8		inst_name
	real*4			x(mn), y(mn), e(mn)
	external ferror_add

	open(unit=48,status='old',form='unformatted',err=950)
	read(48,err=960) (y(i),i=1,lpt),(e(i),i=1,lpt),
     +		xcaption,ycaption,long_title,
     +		xcode,ycode,
     +		(user_par(i),i=1,30),(st_var(i),i=1,20),
     +		ws_history
	close(unit=48,status='delete',err=970)
	ierror = 0
	return
 950    call ferror_add('FUNC_IN', 'unable to open file',
     1			' ')
	ierror = 1
	return
 960    call ferror_add('FUNC_IN', 'unable to read file',
     1			' ')
	ierror = 2
	return
 970    call ferror_add('FUNC_IN', 'unable to close and delete file',
     1			' ')
	ierror = 3
	return
	end
C
C -------------------------------------------------------------C
C
C *** hacked from Genie V2 LOAD_COMMAND.FOR
C
	subroutine load_out(infiletem, ierror)
	implicit none
C
C *** ierror = 0 on success
C              1 on open error
C              2 on write error
C              3 on close error
C
	character*40 infiletem
	integer ierror
	external ferror_add
	open(unit=47,status='unknown',form='unformatted',err=900)
	write(47,err=910) infiletem
	close(unit=47,err=920)
	ierror = 0
	return
 900	call ferror_add('LOAD_OUT', 
     1                  'Unable to open intermediate file',
     2			' ')
	ierror = 1
	return
 910    call ferror_add('LOAD_OUT', 
     1                  'Unable to write to intermediate file',
     2 			'over quota or in the wrong directory')
	ierror = 2
	return
 920	call ferror_add('LOAD_OUT', 
     1                  'Unable to close intermediate file',
     2			' ')
	ierror = 3
	end
C -------------------------------------------------------------C
C
	subroutine load_in(lptem,x,y,e,
     +		xcaption,ycaption,long_title,
     +		delta,inst_code,inst_name,
     +		xcode,ycode,L1,L2,tthet,
     +		no_spectrum,run_number,run_user,
     +		run_duration,start_time,fi,
     +		user_par,st_var,ws_history,ierror)

	implicit none
C
C *** ierror = 0 on success
C              1 on open error
C              2 on write error
C              3 on close error
C
	integer			mn, data_unit
	parameter		(mn=33000)
	real			L1,L2,delta,tthet,run_duration,fi
	integer			run_number,xcode,ycode,lptem
	integer 		ierror, i, inst_code, no_spectrum
  	real 			user_par(30), st_var(20)
	character*200		ws_history
	character*80		long_title
	character*40		infile,xcaption,ycaption
	character*20		run_user,start_time
	character*8		inst_name
	real*4			x(mn), y(mn), e(mn)
	external ferror_add
C
	open(unit=48,status='old',form='unformatted',err=950)
	read(48,err=960) lptem,(x(i),i=1,lptem+1),
     +		(y(i),i=1,lptem),(e(i),i=1,lptem),
     +		xcaption,ycaption,long_title,
     +		delta,inst_code,inst_name,
     +		xcode,ycode,L1,L2,tthet,
     +		no_spectrum,run_number,run_user,
     +		run_duration,start_time,fi,
     +		(user_par(i),i=1,30),(st_var(i),i=1,20),
     +		ws_history
	close(unit=48,status='delete',err=970)
	return
 950	call ferror_add('LOAD_IN', 
     1			'Unable to open intermediate file',
     2			' ')
	ierror = 1
	return
 960    call ferror_add('LOAD_IN', 
     1			'Unable to read intermediate file - probably corrupted',
     2 			' ')
	ierror = 2
	return
 970    call ferror_add('LOAD_IN', 
     1			'Unable to close and delete intermediate file',
     2 			' ')
	ierror = 3
	return
	end
