/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include "g_types.h"
#include "Pginclude.h"
#include "two_d_plot.h"
#include "pg_coord_trans_func.h"

static const char* rcsid = "@(#)$Id: two_d_plot.cxx,v 1.13 1997/05/06 09:57:17 cmm Exp $";
USE_RCSID(rcsid);

int TwoDimensionalPlot::setupValues(g_real* values, int dim1, int dim2)
{
    int dims_array[2] = { dim1, dim2 };
    m_values.setup(values, dims_array, 2);
    return 0;
}

TwoDimensionalPlot::TwoDimensionalPlot(g_real* values, int dim1, int dim2, TwoDimensionalCoordinateTransformFunction* ctf) : 
	NDimensionalPlot(ctf)
{
    setupValues(values, dim1, dim2);
}

int TwoDimensionalPlot::setupFunction(coord_tran_func_t func)
{
    m_func = new PGCoordinateTransformFunction(func);
    return 0;
}

int TwoDimensionalPlot::setupFunction(g_real* x, int* x_dims, int nx_dims, CoordinateTransformMode x_mode,
					g_real*y, int* y_dims, int ny_dims, CoordinateTransformMode y_mode)
{
    m_func = new PGCoordinateTransformFunction(x, x_dims, nx_dims, x_mode, y, y_dims, ny_dims, y_mode);
    return 0;
}

int TwoDimensionalPlot::setupFunction(g_real* matrix)
{
    m_func = new PGCoordinateTransformFunction(matrix);
    return 0;
}
