/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <sys/utsname.h>
#include <string.h>
#include <stdlib.h>
#include "vms_uname.h"

int uname(struct utsname* name)
{
    char* nodename = getenv("UCX$INET_HOST");
    static char* sysname = "VMS";
    static char* version = "";
    static char* release = "6.2";
    static char* machine = "Alpha";

    strncpy(name->sysname, sysname, _SYS_NMLN);    
    strncpy(name->nodename, (nodename != 0 ? nodename : "<unknown>"), _SYS_NMLN);    
    strncpy(name->release, release, _SYS_NMLN);    
    strncpy(name->version, version, _SYS_NMLN);    
    strncpy(name->machine, machine, _SYS_NMLN);    
    return 0;
}
