/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef	__UNITS_P_H__
#define	__UNITS_P_H__

/* prototypes */

int convert_units(g_real[], g_real[], g_real[], g_integer*, const char*,
		  const char**, const char*, const char**, g_integer, g_real, g_real,
		  g_integer, g_real, g_real, g_real*, g_real, g_real, g_real);

int unit_code(const char *, char);

const char* unit_name(int, char);

char* convert_units_errmsg(void);

g_integer truncate(g_real[], g_real[], g_real[], g_integer, g_real, g_real);

int energyToTOF(g_real scale, g_integer emode, g_real efixed, g_real xarray[],
                g_integer ntc, g_real l1, g_real l2);

int TOFToEnergy(g_real scale, g_integer emode, g_real efixed, g_real xarray[],
                g_integer ntc, g_real l1, g_real l2);
#endif /* __UNITS_P_H__ */
