/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <pwd.h>
#include <descrip.h>

/* 
 * functions needed prior to VMS 7.0 
 */

#if defined(__VMS) && __VMS_VER < 70000000

#include "vms_password_funcs.h"

#define MAX_NAMELEN 32

struct passwd* getpwuid(uid_t uid)
{
    static struct passwd pass;
    static char unknown[64];
    static struct dsc$descriptor_s namebuf = { MAX_NAMELEN, DSC$K_DTYPE_T, 
	DSC$K_CLASS_S, 0 };
    unsigned long namelen = 0;
    gid_t gid = 0;
    namebuf.dsc$a_pointer = (char*)malloc(1+MAX_NAMELEN);
    pass.pw_uid = uid;
    if (uid == getuid())
    {
	gid = getgid();
    }
    sprintf(unknown, "Unknown <VMS UIC=[%o,%o]>", gid, uid);
    pass.pw_gid = gid;
    pass.pw_dir = "SYS$LOGIN";
    uid |= gid << 16;
    if (sys$idtoasc(uid, &namelen, &namebuf, 0, 0, 0) & 1)
    {
	pass.pw_name = namebuf.dsc$a_pointer;
     	pass.pw_name[namelen] = '\0';
    }
    else
    {
        pass.pw_name = unknown;
    }
    pass.pw_shell = "DCL";
    return &pass;
}

char* getlogin(void)
{
    static char buffer[MAX_NAMELEN+1];
    struct passwd* pass;
    pass = getpwuid(getuid());
    return strcpy(buffer, pass->pw_name);
}

struct passwd* getpwnam(const char* name)
{
    static struct passwd pass;
    pass.pw_name = (char*)malloc(1+strlen(name));
    strcpy(pass.pw_name, name);
    pass.pw_uid = 0;
    pass.pw_gid = 0;
    pass.pw_dir = "SYS$LOGIN";
    pass.pw_shell = "DCL";
    return &pass;
}

#endif /* defined(__VMS) && __VMS_VER < 70000000 */
